/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2003 Andy DePue <sir_anodos@yahoo.com>                         *
 *  Copyright (C) 2003-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/

#define BUILDING_CUSTOM_LIB
#include "superwaba.h"
#include "CustomLib.h"

/*
   To compile XPlatSqlDB2e native library on Pocket PC, you have to be sure
   to disable UNICODE.  This is how to do it in eMbedded Visual C++:
   1. Go to menu Project | Settings.
   2. Select C/C++ tab.
   3. Remove UNICODE and _UNICODE Proprocessor definitions from the
   "Preprocessor definitions:" edit box.

   The same .c and .h file are used whether you are compiling for Palm OS
   or Pocket PC.
*/

#ifdef PALMOS

#define lockheap() SemaphoreReserve(1)
#define unlockheap() SemaphoreRelease(1)
#define DB2E_INLINE	inline

#else

#define lockheap()
#define unlockheap()
#define DB2E_INLINE

#endif

#ifdef __SWNATIVE_CUSTOM_LIB_H
You included the wrong CustomLib.h file. Be sure it is NOT the
SWNatives\CustomLib.h. If you are using CodeWarrior, Specify in the "Access path"
the directory where your CustomLib.h file resides, moving it to the top. This must
be done because a project (like SuperWaba) can have multiple CustomLib.h
files in different directories, and as default the compiler gets it from
the first directory found.
#endif

#ifdef WINCE // WINCE SPECIFIC
 #include "ce\SWNatives\SWLib.c"
#endif

#define WOBJ_BoundIntValue(o)         (o)[1].intValue
#define WOBJ_BoundIntNullIndicator(o) (o)[2].intValue
#define WOBJ_BoundShortValue(o)       (o)[1].intValue

#define WOBJ_BoundStringBuf(o)        (o)[1].obj
#define WOBJ_BoundStringCurLength(o)  (o)[2].intValue

#define WOBJ_BoundBlobBuf(o)          (o)[1].obj
#define WOBJ_BoundBlobLength(o)       (o)[2].intValue

#define WOBJ_ColumnInfoName(o)        (o)[1].obj
#define WOBJ_ColumnInfoType(o)        (o)[2].intValue
#define WOBJ_ColumnInfoPrecision(o)   (o)[3].intValue
#define WOBJ_ColumnInfoScale(o)       (o)[4].intValue
#define WOBJ_ColumnInfoAllowNulls(o)  (o)[5].intValue

#define WOBJ_BoundTimestampYear(o)    (o)[1].intValue
#define WOBJ_BoundTimestampMonth(o)   (o)[2].intValue
#define WOBJ_BoundTimestampDay(o)     (o)[3].intValue
#define WOBJ_BoundTimestampHour(o)    (o)[4].intValue
#define WOBJ_BoundTimestampMinute(o)  (o)[5].intValue
#define WOBJ_BoundTimestampSecond(o)  (o)[6].intValue
#define WOBJ_BoundTimestampFraction(o) (o)[7].intValue
#define WOBJ_BoundTimestampNullIndicator(o) (o)[8].intValue
#define WOBJ_BoundTimestampStruct(o)  (o)[9].obj

#define WOBJ_DB2ExceptionSQLState(o)  (o)[2].obj
#define WOBJ_DB2ExceptionNativeErr(o) (o)[3].intValue
#define WOBJ_DB2ExceptionSQLErr(o)    (o)[4].intValue

#define SWDB2E_MAX_CONNECTIONS        16


void ThrowDB2Exception(SQLSMALLINT handleType, SQLHANDLE handle, SQLRETURN err, char *pszDescription);

void Db2eAllocHandle(Var stack[]);
void Db2eFreeHandle(Var stack[]);
void Db2eResetStatementParams(Var stack[]);
void Db2eConnect(Var stack[]);
void Db2eDisconnect(Var stack[]);
void Db2ePrepare(Var stack[]);
void Db2eExecute(Var stack[]);
void Db2eExecDirect(Var stack[]);
void Db2eEndTran(Var stack[]);
void Db2eGetRowCount(Var stack[]);
void Db2eSetAutoCommit(Var stack[]);
void Db2eSetCursorType(Var stack[]);
void Db2eSetDeleteMode(Var stack[]);
void Db2eSetReadMode(Var stack[]);
void Db2eSetDirtybitMode(Var stack[]);
void Db2eSetReorgMode(Var stack[]);
void Db2eBindBlob(Var stack[]);
void Db2eBindString(Var stack[]);
void Db2eBindInteger(Var stack[]);
void Db2eBindTime(Var stack[]);
void Db2eBindDate(Var stack[]);
void Db2eBindTimestamp(Var stack[]);
void Db2eGetBlob(Var stack[]);
void Db2eGetString(Var stack[]);
void Db2eGetInteger(Var stack[]);
void Db2eGetTime(Var stack[]);
void Db2eGetDate(Var stack[]);
void Db2eGetTimestamp(Var stack[]);
void Db2eFetch(Var stack[]);
void Db2eFetchScroll(Var stack[]);
void Db2eGetNumResultCols(Var stack[]);
void Db2eDescribeCol(Var stack[]);
void Db2eBindBlobParam(Var stack[]);
void Db2eBindCharParam(Var stack[]);
void Db2eBindDecimalParam(Var stack[]);
void Db2eBindIntegerParam(Var stack[]);
void Db2eBindSmallIntParam(Var stack[]);
void Db2eBindVcParam(Var stack[]);
void Db2eBindTimeParam(Var stack[]);
void Db2eBindDateParam(Var stack[]);
void Db2eBindTimestampParam(Var stack[]);
void BtsTranslateToDb2e(Var stack[]);
void BtsTranslateFromDb2e(Var stack[]);
void BtTranslateToDb2e(Var stack[]);
void BtTranslateFromDb2e(Var stack[]);
void BdTranslateToDb2e(Var stack[]);
void BdTranslateFromDb2e(Var stack[]);

uint32 nativeHashes[48] =
{
	2263920660,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eAllocHandle_(II)I
	2263914771,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eFreeHandle_(II)V
	2263915100,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eResetStatementParams_(I)V
	2263891461,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eConnect_(ILjava/lang/String;Ljava/lang/String;Ljava/lang/String;)V
	2263913938,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eDisconnect_(I)V
	2263936801,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2ePrepare_(ILjava/lang/String;)V
	2263894031,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eExecute_(I)V
	2263888740,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eExecDirect_(ILjava/lang/String;)V
	2263900881,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eEndTran_(III)V
	2263918675,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetRowCount_(I)I
	2263938390,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eSetAutoCommit_(IZ)V
	2263939222,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eSetCursorType_(II)V
	2263934614,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eSetDeleteMode_(II)V
	2263920852,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eSetReadMode_(II)V
	2263884952,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eSetDirtybitMode_(II)V
	2263929237,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eSetReorgMode_(II)V
	2263935875,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindBlob_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundBlob;)V
	2263902087,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindString_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundString;)V
	2263886405,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindInteger_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundInt;)V
	2263937923,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindTime_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTime;)V
	2263935747,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindDate_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundDate;)V
	2263877133,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindTimestamp_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTimestamp;)V
	2263904594,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetBlob_(II[B)I
	2263920468,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetString_(II[B)I
	2263904116,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetInteger_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundInt;)Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundInt;
	2263896499,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetTime_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTime;)Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTime;
	2263893235,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetDate_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundDate;)Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundDate;
	2263936386,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetTimestamp_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTimestamp;)Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTimestamp;
	2263879373,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eFetch_(I)Z
	2263928597,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eFetchScroll_(III)Z
	2263885848,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eGetNumResultCols_(I)I
	2263899399,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eDescribeCol_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eColumnInfo;)V
	2263902152,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindBlobParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundBlob;)V
	2263917962,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindCharParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundString;)V
	2263920907,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindDecimalParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundInt;I)V
	2263918218,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindIntegerParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundInt;)V
	2263923723,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindSmallIntParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundInt;)V
	2263905352,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindVcParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundString;)V
	2263904200,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindTimeParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTime;)V
	2263902024,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindDateParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundDate;)V
	2263908946,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_Db2eBindTimestampParam_(IILsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTimestamp;)V
	2263940044,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_BtsTranslateToDb2e_(Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTimestamp;)V
	2263887886,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_BtsTranslateFromDb2e_(Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTimestamp;)V
	2263897542,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_BtTranslateToDb2e_(Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTime;)V
	2263910920,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_BtTranslateFromDb2e_(Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundTime;)V
	2263895430,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_BdTranslateToDb2e_(Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundDate;)V
	2263908808,  // superwaba/ext/xplat/sql/db2e/db2ex/NativeMethods_BdTranslateFromDb2e_(Lsuperwaba/ext/xplat/sql/db2e/db2ex/Db2eBoundDate;)V
	0  // Must end with 0
};

#define MAX_ENV_HANDLES (4)
#define MAX_CON_HANDLES (8)

SQLHANDLE envHandles[MAX_ENV_HANDLES];
SQLHANDLE conHandles[MAX_CON_HANDLES];

// build at runtime the nativeFuncs array
NativeFunc nativeFuncs[48];
void buildNativeFuncArray()
{
  int i;

  for(i = 0;i < MAX_ENV_HANDLES;i++)
    envHandles[i] = 0;
  for(i = 0;i < MAX_CON_HANDLES;i++)
    conHandles[i] = 0;

	nativeFuncs[  0] = Db2eAllocHandle;
	nativeFuncs[  1] = Db2eFreeHandle;
	nativeFuncs[  2] = Db2eResetStatementParams;
	nativeFuncs[  3] = Db2eConnect;
	nativeFuncs[  4] = Db2eDisconnect;
	nativeFuncs[  5] = Db2ePrepare;
	nativeFuncs[  6] = Db2eExecute;
	nativeFuncs[  7] = Db2eExecDirect;
	nativeFuncs[  8] = Db2eEndTran;
	nativeFuncs[  9] = Db2eGetRowCount;
	nativeFuncs[ 10] = Db2eSetAutoCommit;
	nativeFuncs[ 11] = Db2eSetCursorType;
	nativeFuncs[ 12] = Db2eSetDeleteMode;
	nativeFuncs[ 13] = Db2eSetReadMode;
	nativeFuncs[ 14] = Db2eSetDirtybitMode;
	nativeFuncs[ 15] = Db2eSetReorgMode;
	nativeFuncs[ 16] = Db2eBindBlob;
	nativeFuncs[ 17] = Db2eBindString;
	nativeFuncs[ 18] = Db2eBindInteger;
	nativeFuncs[ 19] = Db2eBindTime;
	nativeFuncs[ 20] = Db2eBindDate;
	nativeFuncs[ 21] = Db2eBindTimestamp;
	nativeFuncs[ 22] = Db2eGetBlob;
	nativeFuncs[ 23] = Db2eGetString;
	nativeFuncs[ 24] = Db2eGetInteger;
	nativeFuncs[ 25] = Db2eGetTime;
	nativeFuncs[ 26] = Db2eGetDate;
	nativeFuncs[ 27] = Db2eGetTimestamp;
	nativeFuncs[ 28] = Db2eFetch;
	nativeFuncs[ 29] = Db2eFetchScroll;
	nativeFuncs[ 30] = Db2eGetNumResultCols;
	nativeFuncs[ 31] = Db2eDescribeCol;
	nativeFuncs[ 32] = Db2eBindBlobParam;
	nativeFuncs[ 33] = Db2eBindCharParam;
	nativeFuncs[ 34] = Db2eBindDecimalParam;
	nativeFuncs[ 35] = Db2eBindIntegerParam;
	nativeFuncs[ 36] = Db2eBindSmallIntParam;
	nativeFuncs[ 37] = Db2eBindVcParam;
	nativeFuncs[ 38] = Db2eBindTimeParam;
	nativeFuncs[ 39] = Db2eBindDateParam;
	nativeFuncs[ 40] = Db2eBindTimestampParam;
	nativeFuncs[ 41] = BtsTranslateToDb2e;
	nativeFuncs[ 42] = BtsTranslateFromDb2e;
	nativeFuncs[ 43] = BtTranslateToDb2e;
	nativeFuncs[ 44] = BtTranslateFromDb2e;
	nativeFuncs[ 45] = BdTranslateToDb2e;
	nativeFuncs[ 46] = BdTranslateFromDb2e;
	nativeFuncs[ 47] = 0;  // Must end with 0
}


DB2E_INLINE int recordEnvHandle(SQLHANDLE handle)
{
  int i;
  for(i = 0;i < MAX_ENV_HANDLES;i++)
  {
    if(envHandles[i] == 0)
    {
      envHandles[i] = handle;
      return 1;
    }
  }

  return 0;
}

DB2E_INLINE int recordConHandle(SQLHANDLE handle)
{
  int i;
  for(i = 0;i < MAX_CON_HANDLES;i++)
  {
    if(conHandles[i] == 0)
    {
      conHandles[i] = handle;
      return 1;
    }
  }

  return 0;
}

DB2E_INLINE int releaseConHandle(SQLHANDLE handle)
{
  int i;
  for(i = 0;i < MAX_CON_HANDLES;i++)
  {
    if(conHandles[i] == handle)
    {
      conHandles[i] = 0;
      return 1;
    }
  }

  return 0;
}

DB2E_INLINE int releaseEnvHandle(SQLHANDLE handle)
{
  int i;
  for(i = 0;i < MAX_ENV_HANDLES;i++)
  {
    if(envHandles[i] == handle)
    {
      envHandles[i] = 0;
      return 1;
    }
  }

  return 0;
}

DB2E_INLINE void disconnectAllConnections()
{
  int i;
  for(i = 0;i < MAX_CON_HANDLES;i++)
  {
    if(conHandles[i] != 0)
    {
      SQLDisconnect(conHandles[i]);
      SQLFreeHandle(SQL_HANDLE_DBC, conHandles[i]);
      conHandles[i] = 0;
    }
  }
}

DB2E_INLINE void freeAllEnvs()
{
  int i;
  for(i = 0;i < MAX_ENV_HANDLES;i++)
  {
    if(envHandles[i] != 0)
    {
      SQLFreeHandle(SQL_HANDLE_ENV, envHandles[i]);
      envHandles[i] = 0;
    }
  }
}


Err callPublic(int index, uint32 *ret, uint32 *args)
{
  return 0;
}

ClassHook *getClassHooks()
{
  return 0;
}

Err handleEvent(EventPtr eventP)
{
  return SWErrEventNotHandled;
}
void onClose()
{
#ifdef PALMOS
  SemaphoreRelease(1); // guich@340_57
#endif
  disconnectAllConnections();
  freeAllEnvs();
#ifdef PALMOS
  SemaphoreReserve(1);
#endif
}

#define SQL_NO_HANDLE_TYPE  (-10)

void ThrowDB2Exception(SQLSMALLINT handleType, SQLHANDLE handle, SQLRETURN err, char *pszDescription)
{
  WObject ret = NULL;
  Char buf[200];
  Char sqlState[10];
  Char errMsg[64];
  SQLINTEGER nativeError;
  // buffer size - description length - extra characters (E=, SS=, N=: ) etc - sqlState - error numbers
  SQLINTEGER bufLength;
  SQLSMALLINT returnedLength = 0;
  SQLRETURN r;
  WObject ss;
  byte *b;
  int i;

  if(pszDescription == NULL)
    pszDescription = "";

  sqlState[5] = '\0';

  bufLength = 198 - StrLen(pszDescription) - 20 - 5 - 24;
  if(bufLength > 62)
    bufLength = 62;

/*  {
    Char dbg[80];
    StrPrintF(dbg, "throw - bufLength=%d", (int)bufLength);
    (*vmGlobals->debug)(dbg);
  } */

  if(handleType != SQL_NO_HANDLE_TYPE && ((r = SQLGetDiagRec(handleType, handle, (SQLSMALLINT)1, (SQLCHAR *)(&sqlState[0]), &nativeError, (SQLCHAR *)errMsg, (SQLSMALLINT)bufLength, &returnedLength)) == SQL_SUCCESS || r == SQL_SUCCESS_WITH_INFO))
  {
    sqlState[5] = '\0';
    StrPrintF(buf, "%s (E=%ld, SS=%s, N=%ld: %s)", pszDescription, (unsigned long)err, sqlState, (unsigned long)nativeError, errMsg);
    ret = (*vmGlobals->throwException)("superwaba/ext/xplat/sql/db2e/db2ex/DB2Exception", buf);
    if(ret != NULL && (*vmGlobals->pushObject)(ret) != -1)
    {
      ss = WOBJ_DB2ExceptionSQLState(ret) = (*vmGlobals->createArrayObject)(8, 5);
      if(ss != NULL && (*vmGlobals->pushObject)(ss) != -1)
      {
        b = (byte *)WOBJ_arrayStart(ss);
/*        {
          Char dbg[80];
          StrPrintF(dbg, "ss=%lx, b=%lx, ret=%lx", (long)ss, (long)b, (long)ret);
          (*vmGlobals->debug)(dbg);
        } */
        for(i = 0;i < 5;i++)
          b[i] = sqlState[i];
        WOBJ_DB2ExceptionNativeErr(ret) = (int32)nativeError;
        WOBJ_DB2ExceptionSQLErr(ret) = (int32)err;
        (*vmGlobals->popObject)();
      }

      (*vmGlobals->popObject)();
    }
  }
  else
  {
    StrPrintF(buf, "%s (%ld)", pszDescription, (unsigned long)err);
    ret = (*vmGlobals->throwException)("superwaba/ext/xplat/sql/db2e/db2ex/DB2Exception", buf);
    if(ret != NULL && (*vmGlobals->pushObject)(ret) != -1)
    {
      ss = WOBJ_DB2ExceptionSQLState(ret) = (*vmGlobals->createArrayObject)(8, 5);
      if(ss != NULL && (*vmGlobals->pushObject)(ss) != -1)
      {
        b = (byte *)WOBJ_arrayStart(ss);
        for(i = 0;i < 5;i++)
          b[i] = ' ';
        WOBJ_DB2ExceptionNativeErr(ret) = 0;
        WOBJ_DB2ExceptionSQLErr(ret) = (int32)r;
        (*vmGlobals->popObject)();
      }
      (*vmGlobals->popObject)();
    }
  }
}

#define MAX_DB2E_TYPE     3
#define MAX_DB2E_FETCH    6
#define MAX_DB2E_ENDTRANS 2
#define MAX_DB2E_CURSOR   2
#define MAX_DB2E_DELETE   2
#define MAX_DB2E_READ     2
#define MAX_DB2E_DIRTYBIT 2
#define MAX_DB2E_REORG    2
#define MAX_DB2E_COLTYPE  9

SQLSMALLINT _typeConversion[MAX_DB2E_TYPE + 1] = {0, SQL_HANDLE_ENV, SQL_HANDLE_DBC, SQL_HANDLE_STMT};
SQLSMALLINT _fetchConversion[MAX_DB2E_FETCH + 1] = {0, SQL_FETCH_NEXT, SQL_FETCH_PRIOR, SQL_FETCH_FIRST, SQL_FETCH_LAST, SQL_FETCH_ABSOLUTE, SQL_FETCH_RELATIVE};
SQLSMALLINT _endTransConversion[MAX_DB2E_ENDTRANS + 1] = {0, SQL_COMMIT, SQL_ROLLBACK};
SQLSMALLINT _cursorConversion[MAX_DB2E_CURSOR + 1] = {0, SQL_CURSOR_FORWARD_ONLY, SQL_CURSOR_STATIC};
SQLSMALLINT _cursorCompanion[MAX_DB2E_CURSOR + 1] = {0, SQL_NONSCROLLABLE, SQL_SCROLLABLE};
SQLSMALLINT _deleteConversion[MAX_DB2E_DELETE + 1] = {0, SQL_DELETE_MARK_ONLY, SQL_DELETE_PHYSICAL_REMOVE};
SQLSMALLINT _readConversion[MAX_DB2E_READ + 1] = {0, SQL_READ_EXCLUDE_MARKED_DELETE, SQL_READ_INCLUDE_MARKED_DELETE};
SQLSMALLINT _dirtybitConversion[MAX_DB2E_DIRTYBIT + 1] = {0, SQL_DIRTYBIT_SET_BY_SYSTEM, SQL_DIRTYBIT_SET_BY_APPLICATION};
SQLSMALLINT _reorgConversion[MAX_DB2E_REORG + 1] = {0, SQL_REORG_ENABLED, SQL_REORG_DISABLED};
SQLSMALLINT _colTypeConversion[MAX_DB2E_COLTYPE + 1] = {0, SQL_BLOB, SQL_CHAR, SQL_DECIMAL, SQL_INTEGER, SQL_SMALLINT, SQL_TYPE_DATE, SQL_TYPE_TIME, SQL_TYPE_TIMESTAMP, SQL_VARCHAR};

DB2E_INLINE int32 convertSQLColTypeToJava(SQLSMALLINT colType)
{
  int i;

  for(i = 1;i <= MAX_DB2E_COLTYPE;i++)
  {
    if(_colTypeConversion[i] == colType)
      return i;
  }

  return 0;
}

//int stmtCount = 0;

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods int db2eAllocHandle(int handleType, int contextHandle)
void Db2eAllocHandle(Var stack[]) // (II)I
{
	int16 handleType = (int16)stack[0].intValue;
	SQLHANDLE contextHandle = (SQLHANDLE)stack[1].intValue;
	SQLHANDLE output;
	SQLSMALLINT type;
	SQLRETURN r;

	if(handleType < 1 || handleType > MAX_DB2E_TYPE)
	{
	  ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for handle type in Db2eAllocHandle.");
	  return;
	}
	else
	  type = _typeConversion[handleType];

  unlockheap();
	if((r = SQLAllocHandle(type, contextHandle, &output)) != SQL_SUCCESS)
	{
	  lockheap();
	  ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, r, "Error calling SQLAllocHandle.");
	  return;
	}

	switch(type)
	{
	  case SQL_HANDLE_ENV:
	    recordEnvHandle(output);
	    break;
	  case SQL_HANDLE_DBC:
	    recordConHandle(output);
	    break;

	  // Debug
/*	  case SQL_HANDLE_STMT:
	    stmtCount++;
	    lockheap();
	    (*vmGlobals->debug)((*vmGlobals->int2str)("stmtCount: ", stmtCount));
	    unlockheap();
	    break; */
	}

  lockheap();
  RETURN32(output)
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eFreeHandle(int handleType, int handle)
void Db2eFreeHandle(Var stack[]) // (II)V
{
	int16 handleType = (int16)stack[0].intValue;
	SQLHANDLE handle = (SQLHANDLE)stack[1].intValue;
	SQLSMALLINT type;
	SQLRETURN r;
	if(handleType < 1 || handleType > MAX_DB2E_TYPE)
	{
	  ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for handle type in Db2eFreeHandle.");
	  return;
	}
	else
	  type = _typeConversion[handleType];

	if((r = SQLFreeHandle(type, handle)) != SQL_SUCCESS)
	{
	  ThrowDB2Exception(type, handle, r, "Error calling SQLFreeHandle in Db2eFreeHandle.");
	  return;
	}

	switch(type)
	{
	  case SQL_HANDLE_ENV:
	    releaseEnvHandle(handle);
	    break;

	  case SQL_HANDLE_DBC:
	    releaseConHandle(handle);
	    break;

	  // Debug
/*	  case SQL_HANDLE_STMT:
	    stmtCount--;
	    lockheap();
	    (*vmGlobals->debug)((*vmGlobals->int2str)("Freed stmtCount: ", stmtCount));
	    unlockheap();
	    break; */
	}
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eResetStatementParams(int statementHandle)
void Db2eResetStatementParams(Var stack[]) // (I)V
{
	SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
	SQLRETURN r;

	if((r = SQLFreeStmt(statementHandle, SQL_RESET_PARAMS)) != SQL_SUCCESS)
	  ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLFreeStmt in Db2eResetStatementParams.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eConnect(int connectionHandle, String serverName, String userName, String authentication)
void Db2eConnect(Var stack[]) // (ILjava/lang/String;Ljava/lang/String;Ljava/lang/String;)V
{
  SQLHDBC connectionHandle = (SQLHDBC)stack[0].intValue;
  UtfString serverName = (*vmGlobals->stringToUtf)(stack[1].obj, STU_NULL_TERMINATE);
  UtfString userName = (*vmGlobals->stringToUtf)(stack[2].obj, STU_NULL_TERMINATE);
  UtfString authentication = (*vmGlobals->stringToUtf)(stack[3].obj, STU_NULL_TERMINATE | STU_USE_STATIC);
  SQLRETURN r;

  unlockheap();
  SQLSetConnectAttr(connectionHandle, SQL_ATTR_LOGIN_TIMEOUT, (SQLPOINTER)((SQLINTEGER)10), SQL_IS_INTEGER);
  if((r = SQLConnect(connectionHandle, (SQLCHAR *)serverName.str, SQL_NTS, (SQLCHAR *)userName.str, SQL_NTS, (SQLCHAR *)authentication.str, SQL_NTS)) != SQL_SUCCESS)
  {
    lockheap();
    ThrowDB2Exception(SQL_HANDLE_DBC, connectionHandle, r, "Error calling SQLConnection.");
    return;
	}

	lockheap();
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eDisconnect(int connectionHandle)
void Db2eDisconnect(Var stack[]) // (I)V
{
	SQLHDBC connectionHandle = (SQLHDBC)stack[0].intValue;
	SQLRETURN r;

	if((r = SQLDisconnect(connectionHandle)) != SQL_SUCCESS)
	  ThrowDB2Exception(SQL_HANDLE_DBC, connectionHandle, r, "Error calling SQLDisconnect.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2ePrepare(int statementHandle, String statement)
void Db2ePrepare(Var stack[]) // (ILjava/lang/String;)V
{
  SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
  UtfString statement = (*vmGlobals->stringToUtf)(stack[1].obj, STU_NULL_TERMINATE | STU_USE_STATIC);
  SQLRETURN r;

  unlockheap();
  if((r = SQLPrepare(statementHandle, (SQLCHAR *)statement.str, SQL_NTS)) != SQL_SUCCESS)
  {
    lockheap();
    ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLPrepare.");
    return;
	}

  lockheap();
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eExecute(int statementHandle)
void Db2eExecute(Var stack[]) // (I)V
{
  SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
  SQLRETURN r;

  unlockheap();
  r = SQLExecute(statementHandle);
  lockheap();

  if(r != SQL_SUCCESS && r != SQL_NO_DATA_FOUND)
    ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLExecute.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eExecDirect(int statementHandle, String statement)
void Db2eExecDirect(Var stack[]) // (ILjava/lang/String;)V
{
  SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
  UtfString statement = (*vmGlobals->stringToUtf)(stack[1].obj, STU_NULL_TERMINATE | STU_USE_STATIC);
  SQLRETURN r;

  unlockheap();
  r = SQLExecDirect(statementHandle, (SQLCHAR *)statement.str, SQL_NTS);
  lockheap();

  if(r != SQL_SUCCESS && r != SQL_NO_DATA_FOUND)
    ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLExecDirect.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eEndTran(int handleType, int handle, int completionType)
void Db2eEndTran(Var stack[]) // (III)V
{
	int16 handleType = (int16)stack[0].intValue;
	SQLHANDLE handle = (SQLHANDLE)stack[1].intValue;
	SQLSMALLINT type;
	int16 completionJava = (int16)stack[2].intValue;
	SQLSMALLINT completionType;
	SQLRETURN r;

	if(handleType < 1 || handleType > MAX_DB2E_TYPE)
	{
	  ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for handle type in Db2eEndTran.");
	  return;
	}
	else
	  type = _typeConversion[handleType];

	if(completionJava < 1 || completionJava > MAX_DB2E_ENDTRANS)
	{
	  ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for completion type in Db2eEndTran.");
	  return;
	}
	else
	  completionType = _endTransConversion[completionJava];

	if((r = SQLEndTran(type, handle, completionType)) != SQL_SUCCESS)
	  ThrowDB2Exception(type, handle, r, "Error calling SQLEndTran in Db2eEndTran.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods int db2eGetRowCount(int statementHandle)
void Db2eGetRowCount(Var stack[]) // (I)I
{
  SQLHANDLE handle = (SQLHANDLE)stack[0].intValue;
  SQLINTEGER count;
  SQLRETURN r;

  unlockheap();
  if((r = SQLRowCount(handle, &count)) != SQL_SUCCESS)
  {
    lockheap();
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLRowCount in Db2eGetRowCount.");
    return;
  }

  lockheap();
  RETURN32(count)
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eSetAutoCommit(int dbcHandle, boolean autocommit)
void Db2eSetAutoCommit(Var stack[]) // (IZ)V
{
  SQLHDBC handle = (SQLHDBC)stack[0].intValue;
  int32 boolValue = stack[1].intValue;
  SQLRETURN r = 0;

  unlockheap();
  if((r = SQLSetConnectAttr(handle, SQL_ATTR_AUTOCOMMIT, (SQLPOINTER)((boolValue == 0) ? SQL_AUTOCOMMIT_OFF : SQL_AUTOCOMMIT_ON), SQL_IS_INTEGER)) != SQL_SUCCESS)
  {
    lockheap();
    ThrowDB2Exception(SQL_HANDLE_DBC, handle, r, "Error calling SQLSetConnectAttr in Db2eSetAutoCommit.");
    return;
  }

  lockheap();
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eSetCursorType(int statementHandle, int type)
void Db2eSetCursorType(Var stack[]) // (II)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLINTEGER type;
  int16 typeJava = (int16)stack[1].intValue;
  SQLRETURN r;

  if(typeJava < 1 || typeJava > MAX_DB2E_CURSOR)
  {
    ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for cursor type in Db2eSetCursorType.");
    return;
  }
  else
    type = _cursorConversion[typeJava];

  if((r = SQLSetStmtAttr(handle, SQL_ATTR_CURSOR_TYPE, (SQLPOINTER)type, SQL_IS_INTEGER)) != SQL_SUCCESS)
  {
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLSetStmtAttr in Db2eSetCursorType.");
    return;
  }

  type = _cursorCompanion[typeJava];

  if((r = SQLSetStmtAttr(handle, SQL_ATTR_CURSOR_SCROLLABLE, (SQLPOINTER)type, SQL_IS_INTEGER)) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLSetStmtAttr for scrollable in Db2eSetCursorType.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eSetDeleteMode(int statementHandle, int mode)
void Db2eSetDeleteMode(Var stack[]) // (II)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLINTEGER mode;
  int16 modeJava = (int16)stack[1].intValue;
  SQLRETURN r;

  if(modeJava < 1 || modeJava > MAX_DB2E_DELETE)
  {
    ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for delete mode in Db2eSetDeleteMode.");
    return;
  }
  else
    mode = _deleteConversion[modeJava];

  if((r = SQLSetStmtAttr(handle, SQL_ATTR_DELETE_MODE, (SQLPOINTER)mode, SQL_IS_INTEGER)) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLSetStmtAttr in Db2eSetDeleteMode.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eSetReadMode(int statementHandle, int mode)
void Db2eSetReadMode(Var stack[]) // (II)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLINTEGER mode;
  int16 modeJava = (int16)stack[1].intValue;
  SQLRETURN r;

  if(modeJava < 1 || modeJava > MAX_DB2E_READ)
  {
    ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for read mode in Db2eSetReadMode.");
    return;
  }
  else
    mode = _readConversion[modeJava];

  if((r = SQLSetStmtAttr(handle, SQL_ATTR_READ_MODE, (SQLPOINTER)mode, SQL_IS_INTEGER)) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLSetStmtAttr in Db2eSetReadMode.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eSetDirtybitMode(int statementHandle, int mode)
void Db2eSetDirtybitMode(Var stack[]) // (II)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLINTEGER mode;
  int16 modeJava = (int16)stack[1].intValue;
  SQLRETURN r;

  if(modeJava < 1 || modeJava > MAX_DB2E_DIRTYBIT)
  {
    ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for dirty bit mode in Db2eSetDirtyBitMode.");
    return;
  }
  else
    mode = _dirtybitConversion[modeJava];

  if((r = SQLSetStmtAttr(handle, SQL_ATTR_DIRTYBIT_SET_MODE, (SQLPOINTER)mode, SQL_IS_INTEGER)) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLSetStmtAttr in Db2eSetDirtybitMode.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eSetReorgMode(int statementHandle, int mode)
void Db2eSetReorgMode(Var stack[]) // (II)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLINTEGER mode;
  int16 modeJava = (int16)stack[1].intValue;
  SQLRETURN r;

  if(modeJava < 1 || modeJava > MAX_DB2E_REORG)
  {
    ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for reorg mode in Db2eSetReorgMode.");
    return;
  }
  else
    mode = _reorgConversion[modeJava];

  if((r = SQLSetStmtAttr(handle, SQL_ATTR_REORG_MODE, (SQLPOINTER)mode, SQL_IS_INTEGER)) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLSetStmtAttr in Db2eSetReorgMode.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindBlob(int statementHandle, int column, superewaba.ext.xplat.db2e.BoundBlob blob)
void Db2eBindBlob(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundBlob;)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
  WObject boundBlob = stack[2].obj;
  WObject blobBuf = WOBJ_BoundBlobBuf(boundBlob);
  SQLPOINTER bufStart = (SQLPOINTER)(WOBJ_arrayStart(blobBuf));
  SQLINTEGER bufferLength = (SQLINTEGER)(WOBJ_arrayLen(blobBuf));
  SQLRETURN r;

  if((r = SQLBindCol(handle, column, SQL_C_BINARY, bufStart, bufferLength, &(WOBJ_BoundBlobLength(boundBlob)))) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindCol in Db2eBindBlob.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindString(int statementHandle, int column, superewaba.ext.xplat.db2e.BoundString str)
void Db2eBindString(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundString;)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
  WObject boundString = stack[2].obj;
  WObject stringBuf = WOBJ_BoundStringBuf(boundString);
  SQLPOINTER bufStart = (SQLPOINTER)(WOBJ_arrayStart(stringBuf));
  SQLINTEGER bufferLength = (SQLINTEGER)(WOBJ_arrayLen(stringBuf));
  SQLRETURN r;

  if((r = SQLBindCol(handle, column, SQL_C_CHAR, bufStart, bufferLength, &(WOBJ_BoundStringCurLength(boundString)))) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindCol in Db2eBindString.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindInteger(int statementHandle, int column, superewaba.ext.xplat.db2e.BoundInt value)
void Db2eBindInteger(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundInt;)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
  SQLRETURN r;

  if((r = SQLBindCol(handle, column, SQL_C_LONG, &(WOBJ_BoundIntValue(stack[2].obj)), 0, &(WOBJ_BoundIntNullIndicator(stack[2].obj)))) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindCol in Db2eBindInteger.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindTime(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundTime time)
void Db2eBindTime(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundTime;)V
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
	WObject boundTime = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundTime);
	TIME_STRUCT *timeStruct = (TIME_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

  if((r = SQLBindCol(handle, column, SQL_C_TYPE_TIME, (SQLPOINTER)timeStruct, sizeof(TIME_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundTime)))) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindCol in Db2eBindTime.");
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindDate(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundDate date)
void Db2eBindDate(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundDate;)V
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
	WObject boundDate = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundDate);
	DATE_STRUCT *dateStruct = (DATE_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

  if((r = SQLBindCol(handle, column, SQL_C_TYPE_DATE, (SQLPOINTER)dateStruct, sizeof(DATE_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundDate)))) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindCol in Db2eBindDate.");
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindTimestamp(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundTimestamp timestamp)
void Db2eBindTimestamp(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundTimestamp;)V
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
	WObject boundTimestamp = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundTimestamp);
	TIMESTAMP_STRUCT *timestampStruct = (TIMESTAMP_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

  if((r = SQLBindCol(handle, column, SQL_C_TYPE_TIMESTAMP, (SQLPOINTER)timestampStruct, sizeof(TIMESTAMP_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundTimestamp)))) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindCol in Db2eBindTimestamp.");
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods int db2eGetBlob(int statementHandle, int column, byte[] buffer)
void Db2eGetBlob(Var stack[]) // (I[I)I
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
  WObject blobBuf = stack[2].obj;
  SQLPOINTER bufStart = (SQLPOINTER)(WOBJ_arrayStart(blobBuf));
  SQLINTEGER bufferLength = (SQLINTEGER)(WOBJ_arrayLen(blobBuf));
  SQLINTEGER lengthOut = 0;
  SQLRETURN r;

  if((r = SQLGetData(handle, column, SQL_C_BINARY, bufStart, bufferLength, &lengthOut)) != SQL_SUCCESS)
  {
    if(r == SQL_SUCCESS_WITH_INFO)
    {
      SQLCHAR sqlState[5];
      SQLINTEGER native;
      SQLCHAR msg[5];
      SQLSMALLINT textLen;
      SQLGetDiagRec(SQL_HANDLE_STMT, handle, 1, sqlState, &native, msg, 5, &textLen);
      {
        if(sqlState[0] == '0' && sqlState[1] == '1' && sqlState[2] == '0' && sqlState[3] == '0' && sqlState[4] == '4')
        {
          RETURN32(bufferLength)
        }
      }
    }
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLGetData in Db2eGetBlob.");
    return;
  }

  RETURN32(lengthOut)
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods int db2eGetString(int statementHandle, int column, byte[] cstr)
void Db2eGetString(Var stack[]) // (I[I)I
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
  WObject stringBuf = stack[2].obj;
  SQLPOINTER bufStart = (SQLPOINTER)(WOBJ_arrayStart(stringBuf));
  SQLINTEGER bufferLength = (SQLINTEGER)(WOBJ_arrayLen(stringBuf));
  SQLINTEGER lengthOut = 0;
  SQLRETURN r;

  if((r = SQLGetData(handle, column, SQL_C_CHAR, bufStart, bufferLength, &lengthOut)) != SQL_SUCCESS)
  {
    if(r == SQL_SUCCESS_WITH_INFO)
    {
      SQLCHAR sqlState[5];
      SQLINTEGER native;
      SQLCHAR msg[5];
      SQLSMALLINT textLen;
      SQLGetDiagRec(SQL_HANDLE_STMT, handle, 1, sqlState, &native, msg, 5, &textLen);
      {
        if(sqlState[0] == '0' && sqlState[1] == '1' && sqlState[2] == '0' && sqlState[3] == '0' && sqlState[4] == '4')
        {
          RETURN32(bufferLength)
        }
      }
    }
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLGetData in Db2eGetString.");
    return;
  }

  RETURN32(lengthOut)
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods BoundInt db2eGetInteger(int statementHandle, int column, BoundInt integer)
// AlD - 7/1/03: Added support for detecting null integer values.  Changed
//               from using a straight 'int' to using the BoundInt.
void Db2eGetInteger(Var stack[]) // (II)I
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
  WObject boundInt = stack[2].obj;
  SQLRETURN r;

  if((r = SQLGetData(handle, column, SQL_C_LONG, &(WOBJ_BoundIntValue(boundInt)), 0, &(WOBJ_BoundIntNullIndicator(boundInt)))) != SQL_SUCCESS)
  {
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLGetData in Db2eGetInteger.");
    return;
  }

  RETURN32(boundInt)
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods superwaba.ext.xplat.sql.db2e.BoundTime db2eGetTime(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundTime time)
void Db2eGetTime(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundTime;)Lsuperwaba/ext/xplat/sql/db2e/BoundTime;
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
	WObject boundTime = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundTime);
	TIME_STRUCT *timeStruct = (TIME_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

  if((r = SQLGetData(handle, column, SQL_C_TYPE_TIME, (SQLPOINTER)timeStruct, sizeof(TIME_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundTime)))) != SQL_SUCCESS)
  {
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLGetData in Db2eGetTime.");
    return;
  }

  RETURN32(boundTime)
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods superwaba.ext.xplat.sql.db2e.BoundDate db2eGetDate(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundDate date)
void Db2eGetDate(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundDate;)Lsuperwaba/ext/xplat/sql/db2e/BoundDate;
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
	WObject boundDate = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundDate);
	DATE_STRUCT *dateStruct = (DATE_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

  if((r = SQLGetData(handle, column, SQL_C_TYPE_DATE, (SQLPOINTER)dateStruct, sizeof(DATE_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundDate)))) != SQL_SUCCESS)
  {
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLGetData in Db2eGetDate.");
    return;
  }

  RETURN32(boundDate)
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods superwaba.ext.xplat.sql.db2e.BoundTimestamp db2eGetTimestamp(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundTimestamp timestamp)
void Db2eGetTimestamp(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundTimestamp;)Lsuperwaba/ext/xplat/sql/db2e/BoundTimestamp;
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT column = (SQLUSMALLINT)stack[1].intValue;
	WObject boundTimestamp = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundTimestamp);
	TIMESTAMP_STRUCT *timestampStruct = (TIMESTAMP_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

  if((r = SQLBindCol(handle, column, SQL_C_TYPE_TIMESTAMP, (SQLPOINTER)timestampStruct, sizeof(TIMESTAMP_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundTimestamp)))) != SQL_SUCCESS)
  {
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLGetData in Db2eGetTimestamp.");
    return;
  }

  RETURN32(boundTimestamp)
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eFetch(int statementHandle)
void Db2eFetch(Var stack[]) // (I)Z
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLRETURN r;

  r = SQLFetch(handle);
  if(r != SQL_SUCCESS)
  {
    if(r == SQL_NO_DATA)
    {
      return;
    }
    else if(r == SQL_SUCCESS_WITH_INFO)
    {
      SQLCHAR sqlState[5];
      SQLINTEGER native;
      SQLCHAR msg[5];
      SQLSMALLINT textLen;
      SQLGetDiagRec(SQL_HANDLE_STMT, handle, 1, sqlState, &native, msg, 5, &textLen);
      if(sqlState[0] == '0' && sqlState[1] == '1' && sqlState[2] == '0' && sqlState[3] == '0' && sqlState[4] == '4')
         return;
    }
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLFetch in Db2eFetch.");
  }
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eFetchScroll(int statementHandle, int fetchOrientation, int fetchOffset)
void Db2eFetchScroll(Var stack[]) // (III)Z
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLSMALLINT orientation = (SQLSMALLINT)stack[1].intValue;
  SQLINTEGER offset = (SQLINTEGER)stack[2].intValue;
  SQLRETURN r;

  if(orientation < 1 || orientation > MAX_DB2E_FETCH)
  {
    ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Illegal value for orientation in Db2eFetchScroll.");
    return;
  }
  else
    orientation = _fetchConversion[orientation];

  r = SQLFetchScroll(handle, orientation, offset);
  if(r != SQL_SUCCESS)
  {
    if(r == SQL_NO_DATA)
    {
      return;
    }
    else if(r == SQL_SUCCESS_WITH_INFO)
    {
      SQLCHAR sqlState[5];
      SQLINTEGER native;
      SQLCHAR msg[5];
      SQLSMALLINT textLen;
      SQLGetDiagRec(SQL_HANDLE_STMT, handle, 1, sqlState, &native, msg, 5, &textLen);
      {
        if(sqlState[0] == '0' && sqlState[1] == '1' && sqlState[2] == '0' && sqlState[3] == '0' && sqlState[4] == '4')
          return;
      }
    }
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLFetchScroll in Db2eFetchScroll.");
  }
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods int db2eGetNumResultCols(int statementHandle)
void Db2eGetNumResultCols(Var stack[]) // (I)I
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLSMALLINT count;
  SQLRETURN r;

//	(*vmGlobals->debug)("In Db2eGetNumResultCols.");
  if((r = SQLNumResultCols(handle, &count)) != SQL_SUCCESS)
  {
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLNumResultCols in Db2eGetNumResultCols.");
    return;
  }

  RETURN32(count)
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eDescribeCol(int statementHandle, int columnNum, superewaba.ext.xplat.db2e.ColumnInfo infoBuf)
void Db2eDescribeCol(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/ColumnInfo;)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT col = (SQLUSMALLINT)stack[1].intValue;
  WObject infoBuf = stack[2].obj;
  SQLCHAR name[64];
  SQLSMALLINT actualNameLength;
  SQLSMALLINT type;
  SQLUINTEGER precision;
  SQLSMALLINT scale;
  SQLSMALLINT nullable;
  SQLRETURN r;

//*vmGlobals->debug)("In Db2eDescribeCol.");
  if(infoBuf == NULL)
  {
    (*vmGlobals->throwException)("java/lang/NullPointerException", "ColumnInfo param must not be null.");
    return;
  }

  if((r = SQLDescribeCol(handle, col, name, 64, &actualNameLength, &type, &precision, &scale, &nullable)) != SQL_SUCCESS)
  {
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLDescribeCol in Db2eDescribeCol.");
    return;
  }

  if(actualNameLength > 63)
  {
    ThrowDB2Exception(SQL_NO_HANDLE_TYPE, 0, 0, "Column name is longer than 63 characters.");
    return;
  }

  WOBJ_ColumnInfoName(infoBuf) = (*vmGlobals->createString)((char *)&name[0]);
  WOBJ_ColumnInfoType(infoBuf) = (int32)convertSQLColTypeToJava(type);
  WOBJ_ColumnInfoPrecision(infoBuf) = (int32)precision;
  WOBJ_ColumnInfoScale(infoBuf) = (int32)scale;
  WOBJ_ColumnInfoAllowNulls(infoBuf) = nullable == SQL_NULLABLE ? 1 : 0;
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindBlobParam(int statementHandle, int paramNum, superewaba.ext.xplat.db2e.BoundBlob blob)
void Db2eBindBlobParam(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundBlob;)V
{
  SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
  SQLUSMALLINT paramNum = (SQLUSMALLINT)stack[1].intValue;
  WObject boundBlob = stack[2].obj;
  WObject blobBuf = WOBJ_BoundBlobBuf(boundBlob);
  SQLPOINTER bufStart = (SQLPOINTER)(WOBJ_arrayStart(blobBuf));
  SQLUINTEGER bufferLength = (SQLUINTEGER)(WOBJ_arrayLen(blobBuf));
  SQLRETURN r;

  if((r = SQLBindParameter(handle, paramNum, SQL_PARAM_INPUT, SQL_C_BINARY, SQL_BLOB, bufferLength, 0, bufStart, bufferLength, &(WOBJ_BoundBlobLength(boundBlob)))) != SQL_SUCCESS)
    ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindParameter in Db2eBindBlobParam.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindCharParam(int statementHandle, int paramNum, superewaba.ext.xplat.db2e.BoundString str)
void Db2eBindCharParam(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundString;)V
{
	SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
	int32 paramNum = stack[1].intValue;
	WObject boundString = stack[2].obj;
	WObject stringBuf = WOBJ_BoundStringBuf(boundString);
   uchar *bytes = (uchar *)WOBJ_arrayStart(stringBuf);
   int32 bufSize = WOBJ_arrayLen(stringBuf);
   SQLRETURN r;

	if((r = SQLBindParameter(statementHandle, (SQLUSMALLINT)paramNum, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, bufSize, 0, bytes, bufSize, &(WOBJ_BoundStringCurLength(boundString)))) != SQL_SUCCESS)
	  ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLBindParameter in Db2eBindCharParam.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindDecimalParam(int statementHandle, int paramNum, superewaba.ext.xplat.db2e.BoundInt value, int decimalDigits)
// AlD - 7/1/03: Added support for detecting null integer values.  Changed
//               from using a straight 'int' to using the BoundInt.
void Db2eBindDecimalParam(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundInt;I)V
{
	SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
	int32 paramNum = stack[1].intValue;
	WObject boundInt = stack[2].obj;
	int32 decimalDigits = stack[3].intValue;
	SQLINTEGER *piLen = &(WOBJ_BoundIntNullIndicator(boundInt));
	SQLRETURN r;

	if(*piLen != SQL_NULL_DATA)
    *piLen = 4;

	if((r = SQLBindParameter(statementHandle, (SQLUSMALLINT)paramNum, SQL_PARAM_INPUT, SQL_C_LONG, SQL_DECIMAL, 0, decimalDigits, &(WOBJ_BoundIntValue(boundInt)), 0, piLen)) != SQL_SUCCESS)
	  ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLBindParameter in Db2eBindDecimalParam.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindIntegerParam(int statementHandle, int paramNum, superewaba.ext.xplat.db2e.BoundInt integer)
// AlD - 7/1/03: Added support for detecting null integer values.  Changed
//               from using a straight 'int' to using the BoundInt.
void Db2eBindIntegerParam(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundInt;)V
{
	SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
	int32 paramNum = stack[1].intValue;
	WObject boundInt = stack[2].obj;
   SQLINTEGER *piLen = &(WOBJ_BoundIntNullIndicator(boundInt));
	SQLRETURN r;

  if(*piLen != SQL_NULL_DATA)
    *piLen = 4;

	if((r = SQLBindParameter(statementHandle, (SQLUSMALLINT)paramNum, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &(WOBJ_BoundIntValue(boundInt)), 0, piLen)) != SQL_SUCCESS)
	  ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLBindParameter in Db2eBindIntegerParam.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindSmallIntParam(int statementHandle, int paramNum, superewaba.ext.xplat.db2e.BoundInt integer)
// AlD - 7/1/03: Added support for detecting null integer values.  Changed
//               from using a straight 'int' to using the BoundInt.
void Db2eBindSmallIntParam(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundInt;)V
{
	SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
	int32 paramNum = stack[1].intValue;
	WObject boundInt = stack[2].obj;
   SQLINTEGER *piLen = &(WOBJ_BoundIntNullIndicator(boundInt));
	SQLRETURN r;

  if(*piLen != SQL_NULL_DATA)
    *piLen = 4;

	if((r = SQLBindParameter(statementHandle, (SQLUSMALLINT)paramNum, SQL_PARAM_INPUT, SQL_C_LONG, SQL_SMALLINT, 0, 0, &(WOBJ_BoundIntValue(boundInt)), 0, piLen)) != SQL_SUCCESS)
	  ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLBindParameter in Db2eBindSmallIntParam.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindVcParam(int statementHandle, int paramNum, superewaba.ext.xplat.db2e.BoundString str)
void Db2eBindVcParam(Var stack[]) // (IILsuperewaba/ext/xplat/db2e/BoundString;)V
{
	SQLHSTMT statementHandle = (SQLHSTMT)stack[0].intValue;
	int32 paramNum = stack[1].intValue;
	WObject boundString = stack[2].obj;
	WObject stringBuf = WOBJ_BoundStringBuf(boundString);
   uchar *bytes = (uchar *)WOBJ_arrayStart(stringBuf);
   int32 bufSize = WOBJ_arrayLen(stringBuf);
   SQLRETURN r;

	if((r = SQLBindParameter(statementHandle, (SQLUSMALLINT)paramNum, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_VARCHAR, 0, 0, bytes, bufSize, &(WOBJ_BoundStringCurLength(boundString)))) != SQL_SUCCESS)
	  ThrowDB2Exception(SQL_HANDLE_STMT, statementHandle, r, "Error calling SQLBindParameter in Db2eBindVarcharParam.");
}


//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindTimeParam(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundTime time)
void Db2eBindTimeParam(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundTime;)V
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT param = (SQLUSMALLINT)stack[1].intValue;
	WObject boundTime = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundTime);
	TIME_STRUCT *timeStruct = (TIME_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

   if((r = SQLBindParameter(handle, param, SQL_PARAM_INPUT, SQL_C_TYPE_TIME, SQL_TYPE_TIME, 0, 0, (SQLPOINTER)timeStruct, sizeof(TIME_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundTime)))) != SQL_SUCCESS)
     ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindParameter in Db2eBindTimeParam.");
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindDateParam(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundDate date)
void Db2eBindDateParam(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundDate;)V
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT param = (SQLUSMALLINT)stack[1].intValue;
	WObject boundDate = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundDate);
	DATE_STRUCT *dateStruct = (DATE_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

   if((r = SQLBindParameter(handle, param, SQL_PARAM_INPUT, SQL_C_TYPE_DATE, SQL_TYPE_DATE, 0, 0, (SQLPOINTER)dateStruct, sizeof(DATE_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundDate)))) != SQL_SUCCESS)
     ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindParameter in Db2eBindDateParam.");
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void db2eBindTimestampParam(int statementHandle, int column, superwaba.ext.xplat.sql.db2e.BoundTimestamp timestamp)
void Db2eBindTimestampParam(Var stack[]) // (IILsuperwaba/ext/xplat/sql/db2e/BoundTimestamp;)V
{
	SQLHSTMT handle = (SQLHSTMT)stack[0].intValue;
	SQLUSMALLINT param = (SQLUSMALLINT)stack[1].intValue;
	WObject boundTimestamp = stack[2].obj;
	WObject javaStruct = WOBJ_BoundTimestampStruct(boundTimestamp);
	TIMESTAMP_STRUCT *timestampStruct = (TIMESTAMP_STRUCT *)(WOBJ_arrayStart(javaStruct));
	SQLRETURN r;

   if((r = SQLBindParameter(handle, param, SQL_PARAM_INPUT, SQL_C_TYPE_TIMESTAMP, SQL_TYPE_TIMESTAMP, 0, 0, (SQLPOINTER)timestampStruct, sizeof(TIMESTAMP_STRUCT), &(WOBJ_BoundTimestampNullIndicator(boundTimestamp)))) != SQL_SUCCESS)
     ThrowDB2Exception(SQL_HANDLE_STMT, handle, r, "Error calling SQLBindParameter in Db2eBindTimestampParam.");
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void btsTranslateToDb2e(superwaba.ext.xplat.sql.db2e.BoundTimestamp bts)
void BtsTranslateToDb2e(Var stack[]) // (Lsuperwaba/ext/xplat/sql/db2e/BoundTimestamp;)V
{
  WObject boundTimestamp = stack[0].obj;
  WObject javaStruct = WOBJ_BoundTimestampStruct(boundTimestamp);
  TIMESTAMP_STRUCT *timestampStruct = (TIMESTAMP_STRUCT *)(WOBJ_arrayStart(javaStruct));

  timestampStruct->year = WOBJ_BoundTimestampYear(boundTimestamp);
  timestampStruct->month = WOBJ_BoundTimestampMonth(boundTimestamp);
  timestampStruct->day = WOBJ_BoundTimestampDay(boundTimestamp);
  timestampStruct->hour = WOBJ_BoundTimestampHour(boundTimestamp);
  timestampStruct->minute = WOBJ_BoundTimestampMinute(boundTimestamp);
  timestampStruct->second = WOBJ_BoundTimestampSecond(boundTimestamp);
  timestampStruct->fraction = WOBJ_BoundTimestampFraction(boundTimestamp);
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void btsTranslateFromDb2e(superwaba.ext.xplat.sql.db2e.BoundTimestamp bts)
void BtsTranslateFromDb2e(Var stack[]) // (Lsuperwaba/ext/xplat/sql/db2e/BoundTimestamp;)V
{
  WObject boundTimestamp = stack[0].obj;
  WObject javaStruct = WOBJ_BoundTimestampStruct(boundTimestamp);
  TIMESTAMP_STRUCT *timestampStruct = (TIMESTAMP_STRUCT *)(WOBJ_arrayStart(javaStruct));

  WOBJ_BoundTimestampYear(boundTimestamp) = timestampStruct->year;
  WOBJ_BoundTimestampMonth(boundTimestamp) = timestampStruct->month;
  WOBJ_BoundTimestampDay(boundTimestamp) = timestampStruct->day;
  WOBJ_BoundTimestampHour(boundTimestamp) = timestampStruct->hour;
  WOBJ_BoundTimestampMinute(boundTimestamp) = timestampStruct->minute;
  WOBJ_BoundTimestampSecond(boundTimestamp) = timestampStruct->second;
  WOBJ_BoundTimestampFraction(boundTimestamp) = timestampStruct->fraction;
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void btTranslateToDb2e(superwaba.ext.xplat.sql.db2e.BoundTime bt)
void BtTranslateToDb2e(Var stack[]) // (Lsuperwaba/ext/xplat/sql/db2e/BoundTime;)V
{
  WObject boundTime = stack[0].obj;
  WObject javaStruct = WOBJ_BoundTimestampStruct(boundTime);
  TIME_STRUCT *timeStruct = (TIME_STRUCT *)(WOBJ_arrayStart(javaStruct));

  timeStruct->hour = WOBJ_BoundTimestampHour(boundTime);
  timeStruct->minute = WOBJ_BoundTimestampMinute(boundTime);
  timeStruct->second = WOBJ_BoundTimestampSecond(boundTime);
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void btTranslateFromDb2e(superwaba.ext.xplat.sql.db2e.BoundTime bt)
void BtTranslateFromDb2e(Var stack[]) // (Lsuperwaba/ext/xplat/sql/db2e/BoundTime;)V
{
  WObject boundTime = stack[0].obj;
  WObject javaStruct = WOBJ_BoundTimestampStruct(boundTime);
  TIME_STRUCT *timeStruct = (TIME_STRUCT *)(WOBJ_arrayStart(javaStruct));

  WOBJ_BoundTimestampHour(boundTime) = timeStruct->hour;
  WOBJ_BoundTimestampMinute(boundTime) = timeStruct->minute;
  WOBJ_BoundTimestampSecond(boundTime) = timeStruct->second;
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void bdTranslateToDb2e(superwaba.ext.xplat.sql.db2e.BoundDate bd)
void BdTranslateToDb2e(Var stack[]) // (Lsuperwaba/ext/xplat/sql/db2e/BoundDate;)V
{
  WObject boundDate = stack[0].obj;
  WObject javaStruct = WOBJ_BoundTimestampStruct(boundDate);
  DATE_STRUCT *dateStruct = (DATE_STRUCT *)(WOBJ_arrayStart(javaStruct));

  dateStruct->year = WOBJ_BoundTimestampYear(boundDate);
  dateStruct->month = WOBJ_BoundTimestampMonth(boundDate);
  dateStruct->day = WOBJ_BoundTimestampDay(boundDate);
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/xplat/sql/db2e/NativeMethods void bdTranslateFromDb2e(superwaba.ext.xplat.sql.db2e.BoundDate bd)
void BdTranslateFromDb2e(Var stack[]) // (Lsuperwaba/ext/xplat/sql/db2e/BoundDate;)V
{
  WObject boundDate = stack[0].obj;
  WObject javaStruct = WOBJ_BoundTimestampStruct(boundDate);
  DATE_STRUCT *dateStruct = (DATE_STRUCT *)(WOBJ_arrayStart(javaStruct));

  WOBJ_BoundTimestampYear(boundDate) = dateStruct->year;
  WOBJ_BoundTimestampMonth(boundDate) = dateStruct->month;
  WOBJ_BoundTimestampDay(boundDate) = dateStruct->day;
}
