/*********************************************************************************
 *  Copyright (C) 2002 Guilherme Campos Hazan <guich@superwaba.org.>             *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library is NOT free software.                                           *
 *  Once you paid for it, you can use it in how many devices you want.           *
 *                                                                               *
 *********************************************************************************/

#define BUILDING_CUSTOM_LIB // must be defined prior to include superwaba.h
#include "superwaba.h"

#include "stdafx.h"
#include "POOMTask.h"
#include "POOMContact.h"
#include "POOMAppointment.h"
#include "PimalIntHelper.h"

#ifdef __SWNATIVE_CUSTOM_LIB_H
You included the wrong CustomLib.h file. Be sure it is NOT the
SWNatives\CustomLib.h.

If you are using CodeWarrior, Specify in the "Access path"
the directory where your CustomLib.h file resides, moving it to the top.

This must be done because a project (like SuperWaba) can have multiple
CustomLib.h files in different directories, and as default the compiler
gets it from the first directory found.
#endif

#ifdef WINCE // WINCE SPECIFIC
 #include "SWLib.c"
#endif

void IpoutlookitemcollectionGetVersion(Var stack[]);
void IpoutlookitemcollectionViewAllContacts(Var stack[]);
void IpoutlookitemcollectionGetAllContacts(Var stack[]);
void IpoutlookitemcollectionViewContact(Var stack[]);
void IpoutlookitemcollectionGetContact(Var stack[]);
void IpoutlookitemcollectionRemoveContact(Var stack[]);
void IpoutlookitemcollectionNewContact(Var stack[]);
void IpoutlookitemcollectionEditContact(Var stack[]);
void IpoutlookitemcollectionViewAllAppointments(Var stack[]);
void IpoutlookitemcollectionViewAppointment(Var stack[]);
void IpoutlookitemcollectionGetAllAppointments(Var stack[]);
void IpoutlookitemcollectionGetAppointment(Var stack[]);
void IpoutlookitemcollectionRemoveAppointment(Var stack[]);
void IpoutlookitemcollectionNewAppointment(Var stack[]);
void IpoutlookitemcollectionEditAppointment(Var stack[]);
void IpoutlookitemcollectionViewTask(Var stack[]);
void IpoutlookitemcollectionViewAllTasks(Var stack[]);
void IpoutlookitemcollectionGetTask(Var stack[]);
void IpoutlookitemcollectionGetAllTasks(Var stack[]);
void IpoutlookitemcollectionRemoveTask(Var stack[]);
void IpoutlookitemcollectionNewTask(Var stack[]);
void IpoutlookitemcollectionEditTask(Var stack[]);

uint32 nativeHashes[23] =
{
	4129893941UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionGetVersion_()Ljava/lang/String;
	4129925498UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionViewAllContacts_()Ljava/lang/String;
	4129917625UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionGetAllContacts_()Ljava/lang/String;
	4129943176UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionViewContact_(Ljava/lang/String;)Ljava/lang/String;
	4129935303UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionGetContact_(Ljava/lang/String;)Ljava/lang/String;
	4129919161UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionRemoveContact_(Ljava/lang/String;)V
	4129892917UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionNewContact_()Ljava/lang/String;
	4129916595UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionEditContact_(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I
	4129888830UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionViewAllAppointments_()Ljava/lang/String;
	4129906508UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionViewAppointment_(Ljava/lang/String;)Ljava/lang/String;
	4129946493UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionGetAllAppointments_()Ljava/lang/String;
	4129898635UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionGetAppointment_(Ljava/lang/String;)Ljava/lang/String;
	4129882493UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionRemoveAppointment_(Ljava/lang/String;)V
	4129921785UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionNewAppointment_()Ljava/lang/String;
	4129934917UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionEditAppointment_(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I
	4129923141UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionViewTask_(Ljava/lang/String;)Ljava/lang/String;
	4129905463UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionViewAllTasks_()Ljava/lang/String;
	4129915268UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionGetTask_(Ljava/lang/String;)Ljava/lang/String;
	4129897590UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionGetAllTasks_()Ljava/lang/String;
	4129899126UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionRemoveTask_(Ljava/lang/String;)V
	4129938418UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionNewTask_()Ljava/lang/String;
	4129888008UL,  // superwaba/ext/ce/io/builtin/NativeMethods_IpoutlookitemcollectionEditTask_(Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I
	0  // Must end with 0
};

// build at runtime the nativeFuncs array
NativeFunc nativeFuncs[23];
void buildNativeFuncArray()
{
	nativeFuncs[  0] = IpoutlookitemcollectionGetVersion;
	nativeFuncs[  1] = IpoutlookitemcollectionViewAllContacts;
	nativeFuncs[  2] = IpoutlookitemcollectionGetAllContacts;
	nativeFuncs[  3] = IpoutlookitemcollectionViewContact;
	nativeFuncs[  4] = IpoutlookitemcollectionGetContact;
	nativeFuncs[  5] = IpoutlookitemcollectionRemoveContact;
	nativeFuncs[  6] = IpoutlookitemcollectionNewContact;
	nativeFuncs[  7] = IpoutlookitemcollectionEditContact;
	nativeFuncs[  8] = IpoutlookitemcollectionViewAllAppointments;
	nativeFuncs[  9] = IpoutlookitemcollectionViewAppointment;
	nativeFuncs[ 10] = IpoutlookitemcollectionGetAllAppointments;
	nativeFuncs[ 11] = IpoutlookitemcollectionGetAppointment;
	nativeFuncs[ 12] = IpoutlookitemcollectionRemoveAppointment;
	nativeFuncs[ 13] = IpoutlookitemcollectionNewAppointment;
	nativeFuncs[ 14] = IpoutlookitemcollectionEditAppointment;
	nativeFuncs[ 15] = IpoutlookitemcollectionViewTask;
	nativeFuncs[ 16] = IpoutlookitemcollectionViewAllTasks;
	nativeFuncs[ 17] = IpoutlookitemcollectionGetTask;
	nativeFuncs[ 18] = IpoutlookitemcollectionGetAllTasks;
	nativeFuncs[ 19] = IpoutlookitemcollectionRemoveTask;
	nativeFuncs[ 20] = IpoutlookitemcollectionNewTask;
	nativeFuncs[ 21] = IpoutlookitemcollectionEditTask;
	nativeFuncs[ 22] = 0;  // Must end with 0
}

// Called by the Lib when a public method is invoked by the vm or someone else. This defines a interface that lets you add custom methods to interface with the vm without modifying the basic architecture of SW Libs
Err callPublic(int index, uint32 *ret, uint32 *args)
{
   return 0; // nothing here to call
}

#define MAX_BSTRS 47 // adding more items must increase this buffer size!
BSTR bstrs[MAX_BSTRS];
uint32 bstrLens[MAX_BSTRS];
IPOutlookApp *outlookApp;

#define FOLDER_TASKS 13
#define FOLDER_CONTACTS 10
#define FOLDER_APPOINTS 9

class POOMFolder
{
public:
	IPOutlookItemCollection *items;
   int size;

   POOMFolder(int id)
   {
   	outlookApp->GetDefaultFolder(id, &folder); 
	   folder->get_Items(&items);
	   items->get_Count(&size);
   }
   ~POOMFolder()
   {
      items->Release();
      folder->Release();
   }

private:
   IFolder *folder;
};

ClassHook *getClassHooks()
{
   HRESULT hr;
   CLSID classId;

   // a good place for initializations
   xmemzero(bstrs,sizeof(bstrs));
   xmemzero(bstrLens,sizeof(bstrLens));

	// No idea what this does: it initialises the outlookApp somehow ...
	IID idIPOutlookApp = {0x05058F22, 0x20BE, 0x11d2,{ 0x8F, 0x18, 0x00,0x00, 0xF8, 0x7A, 0x43, 0x35}}; 
	hr = CLSIDFromProgID(POA_OBJECT, &classId);
	hr = CoCreateInstance(classId, NULL, CLSCTX_INPROC_SERVER, idIPOutlookApp, (LPVOID *) &(outlookApp));	
	// logging on the outlookApp
	hr = outlookApp->Logon(NULL);

   return 0; // nothing here to call
}

// called when this lib is about to be closed. The library must free any allocated resources.
void onClose()
{
   int i;
	HRESULT hr;
   for (i = 0; i < MAX_BSTRS; i++)
      if (bstrLens[i])
      {
         xfree(bstrs[i]);
         bstrLens[i] = 0;
      }
	// logging off the outlookApp
	hr = outlookApp->Logoff();
	// releasing the outlookApp
	hr = outlookApp->Release();
}

// Called by the vm to let the native libraries handle particular events. Must return SWErrEventHandled or SWErrEventNotHandled.
Err handleEvent(EventPtr eventP)
{
   return SWErrEventNotHandled; // Hey, VM, this event was not handled by me, Continue with normal event processing...
}

/** converts the wobject to a bstr string, storing it in an array that is reused */
BSTR createBSTR(Var v, int32 idx)
{
   UtfString16 utf = (*vmGlobals->stringToUtf16)(v.obj);
   if (utf.len > bstrLens[idx]) // needs to expand this position?
   {
      uint32 size = (utf.len+1)<<1;
      bstrLens[idx] = utf.len;
      bstrs[idx] = (BSTR)(*vmGlobals->xrealloc)(bstrs[idx],&size);
      if (bstrs[idx] == NULL)
         bstrLens[idx] = 0;
   }
   if (utf.len > 0 && bstrs[idx] != NULL) // not out of memory?
   {
      xmemmove(bstrs[idx],utf.str,utf.len<<1);
      bstrs[idx][utf.len] = 0; // zero terminated
   } else
   if (utf.len == 0 && bstrs[idx] != NULL)
      bstrs[idx][0] = 0;
   return bstrs[idx];
}

#define LIST_VIEW 1
#define LIST_GET  2

BSTR listTasks(int type) // type: 0 for all, 1 for oid only
{
   int i;
   CString retVal("");
   // getting all the items out of the folder
   POOMFolder folder(FOLDER_TASKS);

	for (i=1; i<=folder.size; i++)
	{
      ITask *obj;
	   folder.items->Item(i, (IDispatch **) &obj);
		POOMTask poom(obj);
		// extract all the data and put it into retVal
      retVal = retVal + ((type==LIST_VIEW)?poom.extractViewData():poom.extractAllData());
	}       
	return retVal.AllocSysString();
}

BSTR listAppoints(int type) // type: 0 for all, 1 for oid only
{
   int i;
   CString retVal("");
   // getting all the items out of the folder
   POOMFolder folder(FOLDER_APPOINTS);

	for (i=1; i<=folder.size; i++)
	{
      IAppointment *obj;
	   folder.items->Item(i, (IDispatch **) &obj);
		POOMAppointment poom(obj);
		// extract all the data and put it into retVal
      retVal = retVal + ((type==LIST_VIEW)?poom.extractViewData():poom.extractAllData());
	}       
	return retVal.AllocSysString();
}

BSTR listContacts(int type) // type: 0 for all, 1 for oid only
{
   int i;
   CString retVal("");
   // getting all the items out of the folder
   POOMFolder folder(FOLDER_CONTACTS);

	for (i=1; i<=folder.size; i++)
	{
      IContact *obj;
	   folder.items->Item(i, (IDispatch **) &obj);
		POOMContact poom(obj);
		// extract all the data and put it into retVal
      retVal = retVal + ((type==LIST_VIEW)?poom.extractViewData():poom.extractAllData());
	}       
	return retVal.AllocSysString();
}

//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionGetVersion()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
void IpoutlookitemcollectionGetVersion(Var stack[]) // ()Ljava/lang/String;
{
	BSTR poomVersion = NULL;
	outlookApp->get_Version(&poomVersion);
	RETURN32((*vmGlobals->createStringFromUnicode)(poomVersion,-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionViewAllContacts()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
void IpoutlookitemcollectionViewAllContacts(Var stack[]) // ()Ljava/lang/String;
{
   BSTR ret = listContacts(LIST_VIEW);
	RETURN32((*vmGlobals->createStringFromUnicode)(ret,-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionGetAllContacts()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
void IpoutlookitemcollectionGetAllContacts(Var stack[]) // ()Ljava/lang/String;
{
   BSTR ret = listContacts(LIST_GET);
	RETURN32((*vmGlobals->createStringFromUnicode)(ret,-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionViewContact(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
void IpoutlookitemcollectionViewContact(Var stack[]) // (Ljava/lang/String;)Ljava/lang/String;
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IContact *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMContact poom(obj);
   CString ret(poom.extractViewData());
	RETURN32((*vmGlobals->createStringFromUnicode)(ret.AllocSysString(),-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionGetContact(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                              
void IpoutlookitemcollectionGetContact(Var stack[]) // (Ljava/lang/String;)Ljava/lang/String;
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IContact *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMContact poom(obj);
   CString ret(poom.extractAllData());
	RETURN32((*vmGlobals->createStringFromUnicode)(ret.AllocSysString(),-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native void ipoutlookitemcollectionRemoveContact(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                             
void IpoutlookitemcollectionRemoveContact(Var stack[]) // (Ljava/lang/String;)V
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IContact *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
	obj->Delete(); 
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionNewContact()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                        
void IpoutlookitemcollectionNewContact(Var stack[]) // ()Ljava/lang/String;
{
   IContact *obj;
   // getting all the items out of the folder
   POOMFolder folder(FOLDER_CONTACTS);
	// now we add it phylically, and return a reference
	folder.items->Add((IDispatch **)&obj); 
   // encapsulate the task and save it
	POOMContact poom(obj,_T("new"));
   BSTR ret = poom.save()?poom.getOid():_T("0");

	RETURN32(vmGlobals->createStringFromUnicode(ret,-1));
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native int ipoutlookitemcollectionEditContact(String oid, String title, String firstName, String middleName, String lastName, String suffix, String jobTitle, String department, String company, String workTel, String workTel2, String homeTel, String homeTel2, String mobileTel, String pager, String carTel, String workFax, String homeFax, String assistantTel, String radioTel, String email, String email2, String email3, String webPage, String workStreet, String workCity, String workState, String workZip, String workCountry, String officeLoc, String homeStreet, String homeCity, String homeState, String homeZip, String homeCountry, String otherStreet, String otherCity, String otherState, String otherZip, String otherCountry, String categories, String assistant, String birthdayAsDateHelperGenericDateString, String anniversaryAsDateHelperGenericDateString, String spouse, String children, String note)
void IpoutlookitemcollectionEditContact(Var stack[]) // (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I
{
   BSTR title        = createBSTR(stack[1],1);
   BSTR firstName    = createBSTR(stack[2],2);
   BSTR middleName   = createBSTR(stack[3],3);
   BSTR lastName     = createBSTR(stack[4],4);
   BSTR suffix       = createBSTR(stack[5],5);
   BSTR jobTitle     = createBSTR(stack[6],6);
   BSTR department   = createBSTR(stack[7],7);
   BSTR company      = createBSTR(stack[8],8);
   BSTR workTel      = createBSTR(stack[9],9);
   BSTR workTel2     = createBSTR(stack[10],10);
   BSTR homeTel      = createBSTR(stack[11],11);
   BSTR homeTel2     = createBSTR(stack[12],12);
   BSTR mobileTel    = createBSTR(stack[13],13);
   BSTR pager        = createBSTR(stack[14],14);
   BSTR carTel       = createBSTR(stack[15],15);
   BSTR workFax      = createBSTR(stack[16],16);
   BSTR homeFax      = createBSTR(stack[17],17);
   BSTR assistantTel = createBSTR(stack[18],18);
   BSTR radioTel     = createBSTR(stack[19],19);
   BSTR email        = createBSTR(stack[20],20);
   BSTR email2       = createBSTR(stack[21],21);
   BSTR email3       = createBSTR(stack[22],22);
   BSTR webPage      = createBSTR(stack[23],23);
   BSTR workStreet   = createBSTR(stack[24],24);
   BSTR workCity     = createBSTR(stack[25],25);
   BSTR workState    = createBSTR(stack[26],26);
   BSTR workZip      = createBSTR(stack[27],27);
   BSTR workCountry  = createBSTR(stack[28],28);
   BSTR officeLoc    = createBSTR(stack[29],29);
   BSTR homeStreet   = createBSTR(stack[30],30);
   BSTR homeCity     = createBSTR(stack[31],31);
   BSTR homeState    = createBSTR(stack[32],32);
   BSTR homeZip      = createBSTR(stack[33],33);
   BSTR homeCountry  = createBSTR(stack[34],34);
   BSTR otherStreet  = createBSTR(stack[35],35);
   BSTR otherCity    = createBSTR(stack[36],36);
   BSTR otherState   = createBSTR(stack[37],37);
   BSTR otherZip     = createBSTR(stack[38],38);
   BSTR otherCountry = createBSTR(stack[39],39);
   BSTR categories   = createBSTR(stack[40],40);
   BSTR assistant    = createBSTR(stack[41],41);
   BSTR birthday     = createBSTR(stack[42],42);
   BSTR anniversary  = createBSTR(stack[43],43);
   BSTR spouse       = createBSTR(stack[44],44);
   BSTR children     = createBSTR(stack[45],45);
   BSTR note         = createBSTR(stack[46],46);
   int oid           = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IContact *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMContact poom(obj, title,  firstName,  middleName,  lastName,  suffix,  jobTitle,  department,  company,  workTel,  workTel2,  homeTel,  homeTel2,  mobileTel,  pager,  carTel,  workFax,  homeFax,  assistantTel,  radioTel,  email,  email2,  email3,  webPage,  workStreet,  workCity,  workState,  workZip,  workCountry,  officeLoc,  homeStreet,  homeCity,  homeState,  homeZip,  homeCountry,  otherStreet,  otherCity,  otherState,  otherZip,  otherCountry,  categories,  assistant,  birthday,  anniversary,  spouse,  children,  note);
   RETURN32(poom.save()?1:0) // save it (this will actually change the data on the device
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionViewAllAppointments()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               
void IpoutlookitemcollectionViewAllAppointments(Var stack[]) // ()Ljava/lang/String;
{
   BSTR ret = listAppoints(LIST_VIEW);
	RETURN32((*vmGlobals->createStringFromUnicode)(ret,-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionGetAllAppointments()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
void IpoutlookitemcollectionGetAllAppointments(Var stack[]) // ()Ljava/lang/String;
{
   BSTR ret = listAppoints(LIST_GET);
	RETURN32((*vmGlobals->createStringFromUnicode)(ret,-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionViewAppointment(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
void IpoutlookitemcollectionViewAppointment(Var stack[]) // (Ljava/lang/String;)Ljava/lang/String;
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IAppointment *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMAppointment poom(obj);
   CString ret(poom.extractViewData());
	RETURN32((*vmGlobals->createStringFromUnicode)(ret.AllocSysString(),-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionGetAppointment(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                          
void IpoutlookitemcollectionGetAppointment(Var stack[]) // (Ljava/lang/String;)Ljava/lang/String;
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IAppointment *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMAppointment poom(obj);
   CString ret(poom.extractAllData());
	RETURN32((*vmGlobals->createStringFromUnicode)(ret.AllocSysString(),-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native void ipoutlookitemcollectionRemoveAppointment(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                         
void IpoutlookitemcollectionRemoveAppointment(Var stack[]) // (Ljava/lang/String;)V
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IAppointment *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
	obj->Delete(); 
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionNewAppointment()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
void IpoutlookitemcollectionNewAppointment(Var stack[]) // ()Ljava/lang/String;
{
   IAppointment *obj;
   // getting all the items out of the folder
   POOMFolder folder(FOLDER_APPOINTS);
	// now we add it phylically, and return a reference
	folder.items->Add((IDispatch **)&obj); 
   // encapsulate the task and save it
	POOMAppointment poom(obj,_T("new"));
   BSTR ret = poom.save()?poom.getOid():_T("0");

	RETURN32(vmGlobals->createStringFromUnicode(ret,-1));
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native int ipoutlookitemcollectionEditAppointment(String oid, String subject, String location, String categories, String reminderSoundFile, String note, String startDate, String endDate, String duration, String meetingStatus, String sensitivity, String busyStatus, String reminderOptions, String reminderMinutesBeforeStart, String allDayEvent, String isRecurring, String reminderSet, String recurrenceType, String occurrences, String interval, String dayOfWeek, String dayOfMonth, String weekOfMonth, String monthOfYear, String patternStartDate, String patternEndDate, String startTime, String endTime, String noEndDate, String recipients)                                                                                                                                                                                                                                                                          
void IpoutlookitemcollectionEditAppointment(Var stack[]) // (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I
{
   BSTR subject            = createBSTR(stack[1],1);
   BSTR location           = createBSTR(stack[2],2);
   BSTR categories         = createBSTR(stack[3],3);
   BSTR reminderSoundFile  = createBSTR(stack[4],4);
   BSTR note               = createBSTR(stack[5],5);
   BSTR startDate          = createBSTR(stack[6],6);
   BSTR endDate            = createBSTR(stack[7],7);
   BSTR duration           = createBSTR(stack[8],8);
   BSTR meetingStatus      = createBSTR(stack[9],9);
   BSTR sensitivity        = createBSTR(stack[10],10);
   BSTR busyStatus         = createBSTR(stack[11],11);
   BSTR reminderOptions    = createBSTR(stack[12],12);
   BSTR reminderMinutesBeforeStart = createBSTR(stack[13],13);
   BSTR allDayEvent        = createBSTR(stack[14],14);
   BSTR isRecurring        = createBSTR(stack[15],15);
   BSTR reminderSet        = createBSTR(stack[16],16);
   BSTR recurrenceType     = createBSTR(stack[17],17);
   BSTR occurrences        = createBSTR(stack[18],18);
   BSTR interval           = createBSTR(stack[19],19);
   BSTR dayOfWeek          = createBSTR(stack[20],20);
   BSTR dayOfMonth         = createBSTR(stack[21],21);
   BSTR weekOfMonth        = createBSTR(stack[22],22);
   BSTR monthOfYear        = createBSTR(stack[23],23);
   BSTR patternStartDate   = createBSTR(stack[24],24);
   BSTR patternEndDate     = createBSTR(stack[25],25);
   BSTR startTime          = createBSTR(stack[26],26);
   BSTR endTime            = createBSTR(stack[27],27);
   BSTR noEndDate          = createBSTR(stack[28],28);
   BSTR recipients         = createBSTR(stack[29],29);
   int oid                 = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   IAppointment *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMAppointment poom(obj, subject, location, categories, reminderSoundFile, note, startDate, endDate, duration, meetingStatus, sensitivity, busyStatus, reminderOptions, reminderMinutesBeforeStart, allDayEvent, isRecurring, reminderSet, recurrenceType, occurrences, interval, dayOfWeek, dayOfMonth, weekOfMonth, monthOfYear, patternStartDate, patternEndDate, startTime, endTime, noEndDate, recipients);
   RETURN32(poom.save()?1:0) // save it (this will actually change the data on the device
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionViewAllTasks()
void IpoutlookitemcollectionViewAllTasks(Var stack[]) // ()Ljava/lang/String;
{
   BSTR ret = listTasks(LIST_VIEW);
	RETURN32((*vmGlobals->createStringFromUnicode)(ret,-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionGetAllTasks()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                       
void IpoutlookitemcollectionGetAllTasks(Var stack[]) // ()Ljava/lang/String;
{
   BSTR ret = listTasks(LIST_GET);
	RETURN32((*vmGlobals->createStringFromUnicode)(ret,-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionViewTask(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
void IpoutlookitemcollectionViewTask(Var stack[]) // (Ljava/lang/String;)Ljava/lang/String;
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   ITask *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMTask poom(obj);
   CString ret(poom.extractViewData());
	RETURN32((*vmGlobals->createStringFromUnicode)(ret.AllocSysString(),-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionGetTask(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                 
void IpoutlookitemcollectionGetTask(Var stack[]) // (Ljava/lang/String;)Ljava/lang/String;
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   ITask *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMTask poom(obj);
   CString ret(poom.extractAllData());
	RETURN32((*vmGlobals->createStringFromUnicode)(ret.AllocSysString(),-1))
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native void ipoutlookitemcollectionRemoveTask(String oid)                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                
void IpoutlookitemcollectionRemoveTask(Var stack[]) // (Ljava/lang/String;)V
{
   int oid = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   ITask *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
	obj->Delete(); 
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native String ipoutlookitemcollectionNewTask()                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                           
void IpoutlookitemcollectionNewTask(Var stack[]) // ()Ljava/lang/String;
{
   ITask *obj;
   // getting all the items out of the folder
	POOMFolder folder(FOLDER_TASKS);
	// now we add it phylically, and return a reference
	folder.items->Add((IDispatch **)&obj); 
   // encapsulate the task and save it
	POOMTask poom(obj,_T("new"));
   BSTR ret = poom.save()?poom.getOid():_T("0");

	RETURN32(vmGlobals->createStringFromUnicode(ret,-1));
}
//////////////////////////////////////////////////////////////////////////
// superwaba/ext/ce/io/builtin/NativeMethods static native int ipoutlookitemcollectionEditTask(String oid, String subject, String categories, String startDate, String dueDate, String importance, String completed, String isRecurring, String duration, String recurrenceType, String occurrences, String interval, String dayOfWeek, String dayOfMonth, String weekOfMonth, String monthOfYear, String patternStartDate, String patternEndDate, String startTime, String endTime, String noEndDate, String sensitivity, String teamTask, String reminderSet, String reminderOptions, String reminderTime, String note)                                                                                                                                                                                                                                                                                                                                                                    
void IpoutlookitemcollectionEditTask(Var stack[]) // (Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)I
{
   BSTR subject         = createBSTR(stack[1],1);
   BSTR categories      = createBSTR(stack[2],2);
   BSTR startDate       = createBSTR(stack[3],3);
   BSTR dueDate         = createBSTR(stack[4],4);
   BSTR importance      = createBSTR(stack[5],5);
   BSTR completed       = createBSTR(stack[6],6);
   BSTR isRecurring     = createBSTR(stack[7],7);
   BSTR duration        = createBSTR(stack[8],8);
   BSTR recurrenceType  = createBSTR(stack[9],9);
   BSTR occurrences     = createBSTR(stack[10],10);
   BSTR interval        = createBSTR(stack[11],11);
   BSTR dayOfWeek       = createBSTR(stack[12],12);
   BSTR dayOfMonth      = createBSTR(stack[13],13);
   BSTR weekOfMonth     = createBSTR(stack[14],14);
   BSTR monthOfYear     = createBSTR(stack[15],15);
   BSTR patternStartDate= createBSTR(stack[16],16);
   BSTR patternEndDate  = createBSTR(stack[17],17);
   BSTR startTime       = createBSTR(stack[18],18);
   BSTR endTime         = createBSTR(stack[19],19);
   BSTR noEndDate       = createBSTR(stack[20],20);
   BSTR sensitivity     = createBSTR(stack[21],21);
   BSTR teamTask        = createBSTR(stack[22],22);
   BSTR reminderSet     = createBSTR(stack[23],23);
   BSTR reminderOptions = createBSTR(stack[24],24);
   BSTR reminderTime    = createBSTR(stack[25],25);
   BSTR note            = createBSTR(stack[26],26);
   int oid             = PimalIntHelper(createBSTR(stack[0],0)).getInt();
   ITask *obj;
   outlookApp->GetItemFromOid(oid,(IDispatch**)&obj);
   POOMTask poom(obj, subject, categories, startDate, dueDate, importance, completed, isRecurring, duration, recurrenceType, occurrences, interval, dayOfWeek, dayOfMonth, weekOfMonth, monthOfYear, patternStartDate, patternEndDate, startTime, endTime, noEndDate, sensitivity, teamTask, reminderSet, reminderOptions, reminderTime, note);
   RETURN32(poom.save()?1:0) // save it (this will actually change the data on the device
}
