/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: SW_libStatic.h,v 1.4 2005/08/12 01:19:51 fdie Exp $ */

#ifndef __SW_LIB_STATIC_H
#define __SW_LIB_STATIC_H


// Used to interface with the VM.
Err SWLibOpenStatic();
Err SWLibCloseStatic();

// Invoke a public method
Err SWCallPublicStatic(LibRefnum inRefnum, int index, uint32 *ret, uint32 *args);
// Gets the NativeFunc given the hash value
Err SWGetNativeFuncStatic(LibRefnum inRefnum, int32 hash, NativeFunc *func);
// Invoke the native method given the native func (faster)
Err SWInvokeNativeFuncStatic(LibRefnum inRefnum, NativeFunc func, Var stack[]);

#endif
/*===========================================================================*/
