/* $Id: AudioPlayer.cpp,v 1.4 2004/09/22 10:38:26 petrus Exp $ */

#include <e32std.h>
#include <f32file.h>
#include "AudioPlayer.h"


/*---------------------------------------------------AudioPlayer::AudioPlayer-+
| Play data from a byte array                                                 |
| Warning: the data must be prefixed by a uint32 containing its length!       |
+----------------------------------------------------------------------------*/
AudioPlayer::AudioPlayer(
   char * data,
   RSemaphore & semAudioIdle
) :
   m_semAudioIdle(semAudioIdle)
{
   TDesC8 & dscData = *((TDesC8 *)data);
   m_audio = CMdaAudioPlayerUtility::NewDesPlayerReadOnlyL(
      dscData,
      *this,
      70, // EMdaPriorityMax,
      EMdaPriorityPreferenceQuality
   );
}

/*---------------------------------------------------AudioPlayer::AudioPlayer-+
| Play data from a file                                                       |
+----------------------------------------------------------------------------*/
AudioPlayer::AudioPlayer(
   unsigned short * path,
   int len,
   RSemaphore & semAudioIdle
) :
   m_semAudioIdle(semAudioIdle)
{
   TFileName dscPath;

   dscPath.Append(path, len);
   m_audio = CMdaAudioPlayerUtility::NewFilePlayerL(
      dscPath,
      *this,
      70, // EMdaPriorityMax,
      EMdaPriorityPreferenceQuality
   );
}

/*--------------------------------------------------AudioPlayer::~AudioPlayer-+
|                                                                             |
+----------------------------------------------------------------------------*/
AudioPlayer::~AudioPlayer()
{
   delete m_audio;
   m_semAudioIdle.Signal();
}

/*----------------------------------------------------------AudioPlayer::play-+
|                                                                             |
+----------------------------------------------------------------------------*/
void AudioPlayer::play()
{
   m_audio->Play();
}

/*----------------------------------------------AudioPlayer::MapcInitComplete-+
| Call back from MMdaAudioPlayerCallback                                      |
+----------------------------------------------------------------------------*/
void AudioPlayer::MapcInitComplete(
   TInt error,
   const TTimeIntervalMicroSeconds& /* duration */
) {
   if (error == KErrNone) {
//    RThread().SetPriority(EPriorityNormal);
      m_audio->SetVolume(m_audio->MaxVolume());
//    m_audio->Play();
   }
   m_semAudioIdle.Signal();
}

/*----------------------------------------------AudioPlayer::MapcPlayComplete-+
| Call back from MMdaAudioPlayerCallback                                      |
+----------------------------------------------------------------------------*/
void AudioPlayer::MapcPlayComplete(TInt /*error*/)
{
   m_semAudioIdle.Signal();
}

/*============================================================================*/
