/* $Id: AudioTone.cpp,v 1.2 2004/09/22 10:38:26 petrus Exp $ */

#include <e32std.h>
#include "AudioTone.h"

/*-------------------------------------------------------AudioTone::AudioTone-+
| Duration is in milliseconds                                                 |
+----------------------------------------------------------------------------*/
AudioTone::AudioTone(
   int frequency,
   int duration,
   RSemaphore & semAudioIdle
) :
   m_semAudioIdle(semAudioIdle)
{
   TTimeIntervalMicroSeconds ttDuration(duration * 1000);
   m_audio = CMdaAudioToneUtility::NewL(*this);
   m_audio->PrepareToPlayTone(frequency, ttDuration);
}

/*------------------------------------------------------AudioTone::~AudioTone-+
|                                                                             |
+----------------------------------------------------------------------------*/
AudioTone::~AudioTone()
{
   m_semAudioIdle.Signal();
   delete m_audio;
}

/*---------------------------------------------AudioTone::MatoPrepareComplete-+
| Call back from MMdaAudioToneObserver                                        |
+----------------------------------------------------------------------------*/
void AudioTone::MatoPrepareComplete(TInt error)
{
   if (error) {
      delete this;
   }else {
      m_audio->SetVolume(m_audio->MaxVolume());
      m_audio->Play();
   }
   m_semAudioIdle.Signal();
}

/*------------------------------------------------AudioTone::MatoPlayComplete-+
| Call back from MMdaAudioToneObserver                                        |
+----------------------------------------------------------------------------*/
void AudioTone::MatoPlayComplete(TInt /*error*/)
{
   delete this;
}

/*===========================================================================*/
