/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: epoc_alloc.cpp,v 1.4 2005/05/14 08:29:49 pgr Exp $ */

#include <e32std.h>
#include <stdlib.h>
#include "epoc_alloc.h"

static RHeap * pHeap = 0;

extern "C" {
   void * epoc_malloc(size_t size) {
      if (pHeap == 0) {
         pHeap = User::ChunkHeap(0, 0x200000, 0x300000, 0x4000);
         if (pHeap == 0) {
            User::Leave(KErrNoMemory);
         }
      }
      return pHeap->Alloc(size);
   }

   void epoc_free(void * cell) {
      pHeap->Free(cell);
   }

   void * epoc_realloc(void * cell, size_t size) {
      return pHeap->ReAlloc(cell, size);
   }
   int epoc_alloc_available() {
      TInt largestBlock;
      return pHeap->Available(largestBlock);
   }
   int epoc_malloc_usable_size(void * cell) {
      return pHeap->AllocLen(cell);
   }

   void epoc_alloc_stat(
      int * totalUsed,
      int * countUsed,
      int * biggestAvail,
      int * totalAvail
   ) {
      *totalUsed = 0;
      *biggestAvail = 0;
      *countUsed = pHeap->AllocSize(*totalUsed);
      *totalAvail = pHeap->Available(*biggestAvail);
   }
};

/*============================================================================*/
