/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: epoc_settings.cpp,v 1.1 2005/03/10 23:32:25 fdie Exp $ */

#include <e32std.h>
#include "epoc_settings.h"

extern "C" {
   /**
    * Use Symbian syscalls to retrieve preferences
    * fdie@502_12
    */
   void epoc_settings_get(char *ds,char *ts,char *dateSep,char *timeSep,int *datefmt,
	                       int *time24h,int *daylightSavings,int *weekStart,int *gmtBias)
   {
      TLocale locale;
      *ds = locale.DecimalSeparator();
      *ts = locale.ThousandsSeparator();
      *dateSep = locale.DateSeparator(1);
      TDateFormat df = locale.DateFormat();
      switch(df)
      {
         case EDateEuropean:
            *datefmt = 2;
            break;
         case EDateJapanese:
            *datefmt = 3;
            break;
         default:
            *datefmt = 1;
            break;
      }
      *timeSep = locale.TimeSeparator(1);
      *weekStart = (locale.StartOfWeek() + 1) % 7;
      *time24h = (locale.TimeFormat() == ETime24);
      *gmtBias = locale.UniversalTimeOffset().Int() / 3600;
      *daylightSavings = locale.QueryHomeHasDaylightSavingOn();
   }
};

/*============================================================================*/
