/* $Id: epoc_sound.h,v 1.6 2004/10/24 07:56:28 petrus Exp $ */

#ifndef _epoc_sound_h
#define _epoc_sound_h

#ifdef __cplusplus
extern "C" {
#endif

/*
|  To play a tone, just call:
|      int epoc_sound_playTone(int frequence, int duration);
|  To play "data" (WAV, etc) you first need to create a handle;
|  - from either a buffer, the first 4 bytes of which is the length of
|    the data that follows:
|      unsigned int epoc_sound_makeBufHandle(char * data);
|  - or from a file:
|       unsigned int epoc_sound_makeFileHandle(unsigned short * path, int len);
|  Then call (as many times as desired)
|     void epoc_sound_playHandle(void * handle);
|  don't forget to free the handle before to exit!
|     void epoc_sound_freeHandle(void * handle);
*/

void epoc_sound_enable(int doIt);

int epoc_sound_playTone(int frequence, int duration);
unsigned int epoc_sound_makeBufHandle(char * data);
unsigned int epoc_sound_makeFileHandle(unsigned short * path, int len);
void epoc_sound_playHandle(void * handle);
void epoc_sound_freeHandle(void * handle);
void epoc_sound_quit();

#ifdef __cplusplus
};
#endif
#endif
/*============================================================================*/
