/* $Id: epoc_startupExe.cpp,v 1.9 2004/10/16 17:14:01 petrus Exp $ */

#include <e32std.h>
#include <e32def.h>
#include <e32svr.h>
#include <e32base.h>
#include <estlib.h>
#include <stdlib.h>
#include <stdio.h>
#include <w32std.h>
#include <apgtask.h>
#include <unistd.h> /*@@*/

#include "SDL_error.h"
#include "epoc_startup.h"

#ifndef EXPORT_C
 #ifdef __VC32__
  #define IMPORT_C __declspec(dllexport)
  #define EXPORT_C __declspec(dllexport)
 #endif
 #ifdef __GCC32__
  #define IMPORT_C
  #define EXPORT_C __declspec(dllexport)
 #endif
#endif

#if defined __WINS__
#include <estw32.h>
#endif

#define main SDL_main
extern "C" int main (int argc, char *argv[], char *envp[]);
static int parseCommandLine(char * cmdline, char ** argv);


extern "C" void systemOutClose();                              /*@@*/
static TBuf<600> msg;                                          /*@@*/
_LIT(KSuperWabaInitFailed, "Init has failed ");                /*@@*/
                                                               /*@@*/
extern "C" {                                                   /*@@*/
   void showError(int error) {                                 /*@@*/
//    TBuf<300> msg;                                           /*@@*/
      systemOutClose();                                        /*@@*/
      msg.Append(KSuperWabaInitFailed);                        /*@@*/
      msg.AppendNum(error);                                    /*@@*/
      User::InfoPrint(msg);                                    /*@@*/
      User::Leave(12345);                                      /*@@*/
   }                                                           /*@@*/
   void showMsg(int no, char * msg1, char * msg2) {            /*@@*/
      char * cp;                                               /*@@*/
      msg.AppendNum(no);                                       /*@@*/
      msg.Append(' ');                                         /*@@*/
      cp = msg1;                                               /*@@*/
      while (*cp) msg.Append((TChar)*cp++);                    /*@@*/
      msg.Append(' ');                                         /*@@*/
      cp = msg2;                                               /*@@*/
      while (*cp) msg.Append((TChar)*cp++);                    /*@@*/
      msg.Append('\n');                                        /*@@*/
   }                                                           /*@@*/
}                                                              /*@@*/


/*------------------------------------------------------floatExceptionHandler-+
|                                                                             |
+----------------------------------------------------------------------------*/
void floatExceptionHandler(TExcType type)
{
   // do nothing
// switch (type) {
// case EExcFloatDenormal:
//    break;
// case EExcFloatDivideByZero:
//    break;
// case EExcFloatInexactResult:
//    break;
// case EExcFloatInvalidOperation:
//    break;
// case EExcFloatOverflow:
//    break;
// case EExcFloatStackCheck:
//    break;
// case EExcFloatUnderflow:
//    break;
// default:
//    showError(16000 + (int)type);
// }
   showError(16000 + (int)type); /*@@*/
}

/*----------------------------------------------------------------------mainL-+
|                                                                             |
+----------------------------------------------------------------------------*/
static void mainL(char * cmdLine)
{
   int argc = 0;
   char ** argv = 0;
   char ** envp = 0;

   #if defined __WINS__
   RWin32Stream::StartServer();    // access to stdin/stdout/stderr
   #endif

   SpawnPosixServerThread();       // Posix multi-thread

   if (cmdLine) {                  // called via the starter
      argc = parseCommandLine(cmdLine, 0);
      argv = (char **) new (ELeave) char *[argc];
      parseCommandLine(cmdLine, argv);
   }else {
      __crt0(argc, argv, envp);
   }

   _REENT;                         // open stdlib

   RThread currentThread;
   currentThread.Rename(_L("SuperWaba"));
   currentThread.SetProcessPriority(EPriorityLow);
   currentThread.SetPriority(EPriorityMuchLess);
   currentThread.SetExceptionHandler(floatExceptionHandler, KExceptionFpe);

   /* Start the main (main is #defined as SDL_main) */
   main(argc, argv, envp);
   if (cmdLine) {
      delete [] argv;
      delete [] cmdLine;
   }
   /* FIXME: what if main exit()? */
   CloseSTDLIB();                  // Close stdlib
}

/*-----------------------------------------------------------parseCommandLine-+
| Parse a command line buffer into arguments                                  |
| If argv is null, it just counts the number of arguments.                    |
+----------------------------------------------------------------------------*/
static int parseCommandLine(char * cmdline, char ** argv)
{
   char * bufp = cmdline;
   int argc = 0;
   int isQuoted;

   while (*bufp)
   {
      /* Skip whitespaces */
      while (*bufp == '~') ++bufp;

      /* Skip over argument */
      isQuoted = *bufp == '^';
      if (isQuoted) ++bufp;
      if (*bufp)
      {
         if (argv) argv[argc] = bufp;
         ++argc;
      }
      if (isQuoted)         /* Skip over quoted */
      {
         while (*bufp && (*bufp != '^'))
         {
            if (argv && (*bufp == '~')) *bufp = ' ';
            ++bufp;
         }
      }
      else
      {                     /* Skip over word */
         while (*bufp && (*bufp != '~')) ++bufp;
      }
      if (*bufp)
      {
         if (argv) *bufp = '\0';
         ++bufp;
      }
   }
   return argc;
}

/*-------------------------------------------------------------getCommandLine-+
|                                                                             |
+----------------------------------------------------------------------------*/
static char * getCommandLine()
{
   char * cmdLine;
   #if defined __WINS__
      RChunk chunkFound;
      RSemaphore semReady;
      TFullName chunkFoundName;
      TFindChunk chunkFinder(KSuperWabaUid);

      if (
         (semReady.OpenGlobal(KSuperWabaUid) != KErrNone) ||
         (chunkFinder.Next(chunkFoundName) != KErrNone) ||
         (chunkFound.Open(chunkFinder) != KErrNone)
      ) {
         return 0;
      }
      #if defined _UNICODE
         TText const * src = (TText const *)chunkFound.Base();
         TInt size = wcstombs(0, (wchar_t const *)src, 0);
         cmdLine = new (ELeave) char[size+1];
         wcstombs(cmdLine, (wchar_t const *)src, size);
      #else
         TUint8 const * src = chunkFound.Base();
         TInt size = strlen(src);
         cmdLine = new (ELeave) char[size+1];
         memcpy(cmdLine, src, size);
      #endif
      cmdLine[size] = 0;
      chunkFound.Close();
      semReady.Signal();
      semReady.Close();
   #else
      TBuf<300> buf;
      RProcess moi;
      moi.CommandLine(buf);
      buf.ZeroTerminate();
      #if defined _UNICODE
         wchar_t const * src = (wchar_t const *)buf.Ptr();
         TInt size = wcstombs(0, (wchar_t const *)src, 0);
         cmdLine = new (ELeave) char[size+1];
         wcstombs(cmdLine, (wchar_t const *)src, size);
      #else
         char const * src = buf.Ptr();
         TInt size = strlen(src);
         cmdLine = new (ELeave) char[size+1];
         memcpy(cmdLine, src, size);
      #endif
      cmdLine[size] = 0;
   #endif
   return cmdLine;
}

/*--------------------------------------------------------------------E32Main-+
|                                                                             |
+----------------------------------------------------------------------------*/
GLDEF_C int E32Main()     // when entering directly.
{
   TInt error;
   TTrap trap;
   CTrapCleanup * cleanup = CTrapCleanup::New();
   if (trap.Trap(error)==0) {
      mainL(getCommandLine());
      TTrap::UnTrap();
   }
   delete cleanup;
   return KErrNone;
}


/*--------------------------------------------------------------- WINS stuff -+
|                                                                             |
+----------------------------------------------------------------------------*/
#ifdef __WINS__           // on the Emulator...
EXPORT_C TInt WinsMain()  // entering through a starter app on WINS
{
   return E32Main();
}

GLDEF_C TInt E32Dll(TDllReason /*aReason*/) {
   return KErrNone;
}
#endif

/*===========================================================================*/
