/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: epoc_time.cpp,v 1.3 2004/12/18 22:34:03 fdie Exp $ */

#include <e32std.h>
#include "epoc_time.h"

extern "C" void systemOutClose();                              /*@@*/
static TBuf<600> msg;                                          /*@@*/
_LIT(KInitHasFailed, "Init has failed ");                      /*@@*/
                                                               /*@@*/
extern "C" {                                                   /*@@*/
   void showError(int error) {                                 /*@@*/
//    TBuf<300> msg;                                           /*@@*/
      systemOutClose();                                        /*@@*/
      msg.Append(KInitHasFailed);                              /*@@*/
      msg.AppendNum(error);                                    /*@@*/
      User::InfoPrint(msg);                                    /*@@*/
      User::Leave(12345);                                      /*@@*/
   }                                                           /*@@*/
   void showMsg(int no, char * msg1, char * msg2) {            /*@@*/
      char * cp;                                               /*@@*/
      msg.AppendNum(no);                                       /*@@*/
      msg.Append(' ');                                         /*@@*/
      cp = msg1;                                               /*@@*/
      while (*cp) msg.Append((TChar)*cp++);                    /*@@*/
      msg.Append(' ');                                         /*@@*/
      cp = msg2;                                               /*@@*/
      while (*cp) msg.Append((TChar)*cp++);                    /*@@*/
      msg.Append('\n');                                        /*@@*/
   }                                                           /*@@*/
}                                                              /*@@*/

extern "C" {
   void epoc_time_set(int y, int m, int d, int h, int mn, int s, int ml)
   {
      TTime time;         // time in microseconds since 0AD nominal Gregorian
      TDateTime dateTime; // year-month-day-hour-minute-second-microsecond
      dateTime.Set(y, TMonth(m-1), d-1, h, mn, s, ml);
      time = dateTime;
      User::SetHomeTime(time);
   }
};

/*============================================================================*/
