/*********************************************************************************
 *  SuperWaba Virtual Machine, version 5                                         *
 *  Copyright (C) 2000-2005 SuperWaba Ltda.                                      *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  Please see the software license located at /license.txt for more details.    *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, write to                                                             *
 *                                                                               *
 *     SuperWaba Ltda.                                                           *
 *     Rua Padre Leonel Franca, 480, sala 27A                                    *
 *     Instituto Genesis - PUC-RIO                                               *
 *     Rio de Janeiro / RJ - Brazil                                              *
 *     Cep: 22451-000                                                            *
 *     E-mail: licensing@superwaba.com.br                                        *
 *********************************************************************************/
/* $Id: dirent.h,v 1.3 2004/12/18 22:21:18 fdie Exp $ */

#ifndef _DIRENT_H_
#define _DIRENT_H_
#ifndef WINCE
  #include <io.h>
#endif
#include <tchar.h>

#ifdef __cplusplus
extern "C" {
#endif

struct dirent 
{
   long     d_ino;            /* Always zero. */
   unsigned short d_reclen;   /* Always zero. */
   unsigned short d_namlen;   /* Length of name in d_name. */
   unsigned char d_type;      /* entry type */
   TCHAR const * d_name;      /* File name. */
};

/* BSD only */
#define DT_UNKNOWN 0
#define DT_FIFO 1
#define DT_CHR 2
#define DT_DIR 4
#define DT_BLK 6
#define DT_REG 8
#define DT_LNK 10
#define DT_SOCK 12


typedef struct __dirstream DIR;

DIR * opendir(TCHAR const *);
struct dirent* readdir (DIR*);
int closedir (DIR*);
void rewinddir (DIR*);
long telldir (DIR*);
void seekdir (DIR*, long);

#ifdef   __cplusplus
}
#endif
#endif
/*============================================================================*/
